package sim_calc;

import java.io.FileInputStream;
import java.io.ObjectInputStream;

import org.apache.commons.math.stat.correlation.Covariance;
import org.apache.commons.math.stat.descriptive.moment.StandardDeviation;

public class Confronto_CC_rw_lin {

	public static void main(String[] args) {
		/* carico dimanzione vettore similarit */
		int size=0;
		ObjectInputStream ois;
		System.out.println("start load CC RWLIN...");
		try{
			ois = new ObjectInputStream(new FileInputStream("corr2/Sim_CC/sim_size_CC_RWLIN"));
		    size = (Integer) ois.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading sim_size");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		System.out.println("dimenzione size = "+size);
		
		
		/* carico vettore similarit di sequenza */
		double[] solo_sim = new double[size];
		ObjectInputStream ois2;
		System.out.println("start load vettore_PACCA_sim_seq_CC_RWLIN...");
		try{
			ois2 = new ObjectInputStream(new FileInputStream("corr2/Sim_CC/vettore_PACCA_sim_seq_CC_RWLIN"));
		    solo_sim = (double[]) ois2.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading vettore_sim_seq");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		
		/* carico vettore similarit semantica */
		double[] solo_sim_sem = new double[size];
		ObjectInputStream ois3;
		System.out.println("start load vettore_PACCA_sim_sem_CC_RWLIN...");
		try{
			ois3 = new ObjectInputStream(new FileInputStream("corr2/Sim_CC/vettore_PACCA_sim_sem_CC_RWLIN"));
		    solo_sim_sem = (double[]) ois3.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading vettore_sim_sem");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		/* calcolo deviazione standard per i due vettori */
		StandardDeviation st_dev1 = new StandardDeviation();
		double st_dev_solo_sim =  st_dev1.evaluate(solo_sim);
		
		StandardDeviation st_dev2 = new StandardDeviation();
		double st_dev_solo_sim_sem = st_dev2.evaluate(solo_sim_sem);
		System.out.println("deviazione standard per vettore similarit sequenza = "+st_dev_solo_sim);
		System.out.println("deviazione standard per vettore similarit semantica = "+st_dev_solo_sim_sem);
		
		/* calcolo covarianza tra vettore sim sequenza e vettore sim semantica */
		Covariance cov = new Covariance();
		double cov_seq_sem = cov.covariance(solo_sim, solo_sim_sem);
		System.out.println("covarianza tra vettore sim sequenza e vettore sim semantica = "+cov_seq_sem);
		
		/* calcolo coefficiente di Paerson tra il vettore di sim di sequenza e il vettore si sim semantica */
		double Pearson_seq_sem = ( cov_seq_sem / (st_dev_solo_sim*st_dev_solo_sim_sem) );
		System.out.println("coefficiente di Paerson tra vettore seq e vettore sem = "+Pearson_seq_sem);
		
		//XYBarDataset dati = new XYBarDataset(underlying, ba)
		
		
	}

}
