package annotation;

public class AnnotationDriver {
	/**
	 * AnnotationDriver allows the parsing of the annotation file by calling the method build_table() 
	 * on the instance of Annotation_parser (or Annotation_parser_reduced).
	 * 
	 * @param file: annotation file
	 * 
	 * 			
	 * @see Annotation_parser, Annotation_parser_reduced
	 */

	public static void main(String[] args) {
		
		/* il file delle annotazioni che si desidera analizzare deve essere
		 * scaricato dal sito della geneontology attraverso la classe 
		 * DownloadAnnotFromURL, questa classe memorizza il file sul disco.
		 * Di seguito specifichiamo il percorso per reperire il file
		 */
		String file = "C:/Documents and Settings/Paolo/workspaceTesi/Tesi_Chiusura_Transitiva/GZ_gene_annotation.sgd/gene_annotation.sgd";
		
		/* Creo un oggetto di tipo Annotation_parser_reduced sul quale
		 * invoco il metodo build_table() che di fatto effettua il 
		 * parsing del file indicato e costruisce la corrispondente tabella */
		Annotation_parser_reduced Parser_reduced = new Annotation_parser_reduced(file);
		Parser_reduced.build_table();
		
		/* Stampiamo i record contenuti nella tabella precedentemente creata,
		 * questi record hanno un formato specifico rappresentato dalla classe
		 * Annotation_record (o Annotation_record_reduced). Mentre la tabella 
		 * costruita con il metodo buld_table() viene memorizzata all'interno
		 * della variabile Annotation_Table_reduced della classe 
		 * Annotation_parser_reduced. */
		for(Annotation_record_reduced t:Parser_reduced.Annotations_Table_reduced){
			System.out.println(t.c2_DB_Object_ID+" "+t.c5_GO_ID+" "+t.c7_Evidence_code+" "+t.c9_Aspect);
		}
	}
}
