package annotation;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;


public class Annotation_parser {
	/**
	 * Annotation_parser is a class for parsing 
	 * the annotation file.
	 * The constructor of this class has in input the file to be parsed
	 * The method build_table() builds an array of Annotations_record called Annotations_Table containing the info in the parsed file
	 * the table contains 15 columns (see geneontology format 
	 * 			for annotation files GAF 2.0);
*/
	
	/**  name of file that contains information about annotations of terms **/
    String annotationFilename;    
    /** annotations table **/
    ArrayList<Annotations_record> Annotations_Table;
    
    
    public Annotation_parser(String annotationFilename){
    	
    	this.annotationFilename = annotationFilename;
    	this.Annotations_Table= new ArrayList<Annotations_record>();
    	
    }
    
    public void build_table()
    {
    	try
        {
            FileReader fr = new FileReader(annotationFilename);
            BufferedReader in = new BufferedReader(fr);
            String line;
            System.out.println("Start parsing...");
            while ((line = in.readLine()) != null){
            	//tralasciamo le righe che iniziano con !
            	if(line.startsWith("!")){continue;}
            	
            	/* per ogni linea(riga) letta dal file,
            	 * viene creato un oggetto di tipo 
            	 * Annotations_record(tupla),
            	 * quest'ultimo viene inserito nella
            	 * tabella delle annotazioni(Annotations_table)
            	 */
            	
            	Annotations_record tupla = new Annotations_record();
            	String[] output;
            	output =  line.split("\t");
            	tupla.c1_DB=output[0];
            	//System.out.println("DB = "+tupla.c1_DB);
            	tupla.c2_DB_Object_ID=output[1];
            	//System.out.println("DB_Object_ID = "+tupla.c2_DB_Object_ID);
            	tupla.c3_DB_Object_Symbol=output[2];
            	//System.out.println("DB_Object_Symbol = "+tupla.c3_DB_Object_Symbol);
            	tupla.c4_Qualifier=output[3];
            	//System.out.println("Qualifier = "+tupla.c4_Qualifier);
            	tupla.c5_GO_ID=output[4];
            	//System.out.println("GO_ID = "+tupla.c5_GO_ID);
            	tupla.c6_DB_Reference=output[5];
            	//System.out.println("DB_Reference = "+tupla.c6_DB_Reference);
            	tupla.c7_Evidence_code=output[6];
            	//System.out.println("Evidence_code = "+tupla.c7_Evidence_code);
            	tupla.c8_WithORFrom=output[7];
            	//System.out.println("With (or) From = "+tupla.c8_WithORFrom);
            	tupla.c9_Aspect=output[8];
            	//System.out.println("Aspect = "+tupla.c9_Aspect);
            	tupla.c10_DB_Object_Name=output[9];
            	//System.out.println("DB Object Name = "+tupla.c10_DB_Object_Name);
            	tupla.c11_DB_Object_synonum=output[10];
            	//System.out.println("DB_Object_Synonum = "+tupla.c11_DB_Object_synonum);
            	tupla.c12_DB_Object_Type=output[11];
            	//System.out.println("DB Object Type = "+tupla.c12_DB_Object_Type);
            	tupla.c13_Taxon=output[12];
            	//System.out.println("Taxon = "+tupla.c13_Taxon);
            	tupla.c14_Date=output[13];
            	//System.out.println("Date = "+tupla.c14_Date);
            	tupla.c15_Assigned_By=output[14];
            	//System.out.println("Assigned_by = "+tupla.c15_Assigned_By);
            	/*tupla.c16_Annotation_Extension=output[15];
            	System.out.println("Annotation Extension = "+tupla.c16_Annotation_Extension);
            	tupla.c17_Gene_Product_From_ID=output[16];
            	System.out.println("Gene Product From ID = "+tupla.c17_Gene_Product_From_ID);
            	*/
            	
            	//aggiungo il record alla Annotations Table
            	Annotations_Table.add(tupla);
            	
            }
            System.out.println("END.");
        }
    	catch(IOException e){ }
    }
}
