package annotation;


import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

public class Annotation_parser_reduced {
	/**
	 * alternative version of Annotation_parser. The built annotation table will contain just
	 * 5 columns among the 15 contained in the annotation file: Object_ID; GO_ID; Evidence_code; Aspect.
	 * @see Annotation_parser
	 */

	/**  name of file that contains information about annotations of terms **/
    String annotationFilename;    
    /** annotations table **/
    public ArrayList<Annotation_record_reduced> Annotations_Table_reduced;
    public ArrayList<Annotations_record> Annotation_Table;
    public ArrayList<String> classi_GO; 
    public ArrayList<String> geni; 
    
 public Annotation_parser_reduced(String annotationFilename){
    	
	 	this.Annotation_Table = new ArrayList<Annotations_record>();
    	this.annotationFilename = annotationFilename;
    	this.Annotations_Table_reduced= new ArrayList<Annotation_record_reduced>();
    	this.classi_GO = new ArrayList<String>();
    	this.geni = new ArrayList<String>();
    	
    }
    
    public void build_table()
    {
    	
    	try
        {
            FileReader fr = new FileReader(annotationFilename);
            BufferedReader in = new BufferedReader(fr);
            String line;
            //System.out.println("Start parsing...");
            while ((line = in.readLine()) != null){
            	
            	//tralasciamo le righe che iniziano con !
            	if(line.startsWith("!")){continue;}
            	
            	/* per ogni linea(riga) letta dal file,
            	 * viene creato un oggetto di tipo 
            	 * Annotations_record(tupla),
            	 * quest'ultimo viene inserito nella
            	 * tabella delle annotazioni(Annotations_table)
            	 */
            	Annotations_record tupla = new Annotations_record();
            	Annotation_record_reduced tupla_reduced = new Annotation_record_reduced();
            	String[] output;
            	output =  line.split("\t");
            	tupla.c1_DB=output[0];;
            	tupla.c2_DB_Object_ID=output[1];
            	tupla.c3_DB_Object_Symbol=output[2];
            	tupla.c4_Qualifier=output[3];
            	tupla.c5_GO_ID=output[4];
            	tupla.c6_DB_Reference=output[5];
            	tupla.c7_Evidence_code=output[6];
            	tupla.c8_WithORFrom=output[7];
            	tupla.c9_Aspect=output[8];
            	tupla.c10_DB_Object_Name=output[9];
            	tupla.c11_DB_Object_synonum=output[10];
            	tupla.c12_DB_Object_Type=output[11];
            	tupla.c13_Taxon=output[12];
            	tupla.c14_Date=output[13];
            	tupla.c15_Assigned_By=output[14];
            	//-----//
            	tupla_reduced.c2_DB_Object_ID=output[1];
            	
            	tupla_reduced.c5_GO_ID=output[4];
            	
            	tupla_reduced.c7_Evidence_code=output[6];
            	
            	tupla_reduced.c9_Aspect=output[8];
            	
            	
            	//aggiungo il record alla Annotations Table
            	Annotations_Table_reduced.add(tupla_reduced);
            	Annotation_Table.add(tupla);
            	
            }
            //System.out.println("END.");
        }
    	catch(IOException e){ }
    }
    
    public void build_table_mod(String aspect, ArrayList<String> evidence_ignored)
    {
    	
    	System.out.println("ASP = "+aspect);
    	
    	if(evidence_ignored.get(0).compareTo("all")==0){
    		System.out.println("ALL EVIDENCE CODE CONSIDERED.");
    	}
    	else System.out.println("EVIDENCE CODE IGNORED:\n"+evidence_ignored);
    	
    	
    	try
        {
            FileReader fr = new FileReader(annotationFilename);
            BufferedReader in = new BufferedReader(fr);
            String line;
            
            while ((line = in.readLine()) != null){
            	
            	//tralasciamo le righe che iniziano con !
            	if(line.startsWith("!")){continue;}
            	
            	/* per ogni linea(riga) letta dal file,
            	 * viene creato un oggetto di tipo 
            	 * Annotations_record(tupla),
            	 * quest'ultimo viene inserito nella
            	 * tabella delle annotazioni(Annotations_table)
            	 */
            	
            	String[] output;
            	output =  line.split("\t");
            	
            	if(evidence_ignored.get(0).compareTo("all")==0){
            		
            		if( (output[8].compareTo(aspect)==0) ){
            			
            			Annotation_record_reduced tupla_reduced = new Annotation_record_reduced();
                		
                		tupla_reduced.c2_DB_Object_ID=output[1];
                		if(!geni.contains(tupla_reduced.c2_DB_Object_ID))
                			geni.add(tupla_reduced.c2_DB_Object_ID);
                				
                	
                		tupla_reduced.c5_GO_ID=output[4];
                		if(!classi_GO.contains(tupla_reduced.c5_GO_ID))
                			classi_GO.add(tupla_reduced.c5_GO_ID);
                	
                		tupla_reduced.c7_Evidence_code=output[6];
                	
                		tupla_reduced.c9_Aspect=output[8];
                	
                	
                		//aggiungo il record alla Annotations Table
                		Annotations_Table_reduced.add(tupla_reduced);
            			
            		}
            	}
            	else {
            		
            		if( (output[8].compareTo(aspect)==0) ){
            			boolean ignored = false;
            			
            			/* scorro tutte le evidence da ignorare, se l'evidence
            			 * che sto analizzando durante il parsing  uguale ad una
            			 * di quelle da ignorare allora imposto la variabile ignored=true
            			 * e esco dal for immediatamente. */
            			for(String ev:evidence_ignored){
            				if( (output[6].compareTo(ev)==0)){
            					ignored=true;
            					break;
            				}
            			}
            			
            			/* se ignored=true allora la riga che sto analizzando deve essere 
            			 * ignorata, quindi passo alla successiva. */
            			if(ignored)continue;
            			
            			/* altrimenti la riga che sto analizzando ha aspect= a quella
            			 * immessa dall'utente ed evidence code diverso da tutti
            			 * quelli che l'utente vuole ignorare, quindi devo creare una
            			 * tupla nella tabella risultato con i valori presenti nella riga. */
            			else{
            				Annotation_record_reduced tupla_reduced = new Annotation_record_reduced();
            				Annotations_record tupla = new Annotations_record();
                		
            				tupla_reduced.c2_DB_Object_ID=output[1];
            				tupla.c2_DB_Object_ID=output[1];
            				tupla.c3_DB_Object_Symbol=output[2];
            				if(!geni.contains(tupla_reduced.c2_DB_Object_ID))
            					geni.add(tupla_reduced.c2_DB_Object_ID);
            				
            	
            				tupla_reduced.c5_GO_ID=output[4];
            				tupla.c5_GO_ID=output[4];
            				if(!classi_GO.contains(tupla_reduced.c5_GO_ID))
            					classi_GO.add(tupla_reduced.c5_GO_ID);
            	
            				tupla_reduced.c7_Evidence_code=output[6];
            				tupla.c7_Evidence_code=output[6];
            	
            				tupla_reduced.c9_Aspect=output[8];
            				tupla.c9_Aspect=output[8];
            	
            				//aggiungo il record alla Annotations Table
            				Annotations_Table_reduced.add(tupla_reduced);
            				Annotation_Table.add(tupla);
            			}//chiude else(che aggiunge tupla ala tabella risultato)
            			
            		}//chiude if aspect=quello immesso dall'utente
            		
            	}//chiude else che prende le righe con evidence diverso da quelli da ignorare
            	
            }//chiude while che scorre tutte le righe del file
            
            //System.out.println("END.");
        }
    	catch(IOException e){ }
    }
}


