package annotation;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;


public class GeneAnnotation_parser {
	/**
	 * GeneAnnotation_parser is involved in the process of parsing the annotation files
	   It builds a hashtable in which the keys are the gene IDs, and the value is a string
	   vector containing the GO terms the gene is annotated with.
	 */
	
	/**  name of file that contains information about annotations of terms **/
    String annotationFilename;  
    ArrayList<String> evide;
    /** annotations table **/
    public Hashtable<String, ArrayList<String>> Gene_termini;
    ArrayList<String> lista_geni;
    
    
    public GeneAnnotation_parser(String annotationFilename, ArrayList<String> evidence, ArrayList<String> lista_geni){
    	
    	this.annotationFilename = annotationFilename;
    	this.Gene_termini= new Hashtable<String, ArrayList<String>>();
    	this.evide=evidence;
    	this.lista_geni=lista_geni;
    	
    }
    
    public void build_table()
    {
    	/* inizializzo l'hashtable di output */
    	for(String sr:lista_geni){
    		ArrayList<String> termin = new ArrayList<String>();
    		Gene_termini.put(sr, termin);
    	}
    	//---------------------------------//
    	
    	try
        {
            FileReader fr = new FileReader(annotationFilename);
            BufferedReader in = new BufferedReader(fr);
            String line;
            System.out.println("Start parsing...");
            while ((line = in.readLine()) != null){
            	//tralasciamo le righe che iniziano con !
            	if(line.startsWith("!")){continue;}
            	
            	Annotations_record tupla = new Annotations_record();
            	String[] output;
            	output =  line.split("\t");
            	/* controllo se il gene presente nella riga analizzata  uno di quelli indicati dall'utente */
            	if(lista_geni.contains(output[2])){
            		/* controllo se l'evidence nella riga  una di quelle da ignorare */
            		if(!evide.contains(output[6])){
            			System.out.println("PRIMA - dimenzione lista termini del gene "+output[2]+" = "+Gene_termini.get(output[2]).size());
            			if(!Gene_termini.get(output[2]).contains(output[6]))Gene_termini.get(output[2]).add(output[4]);//aggiungo termini alla lista dei termini annotati con il gene  	
            			System.out.println("DOPO - dimenzione lista termini del gene "+output[2]+" = "+Gene_termini.get(output[2]).size());
            		}
            	}
            	
            }
            System.out.println("END.");
        }
    	catch(IOException e){ }
    }
}

