package annotation;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Hashtable;

import sim_calc.FileIn;
/* This Class provides the method storeAnnotations to parse the annotation file
 * INPUT
 		  path_to_annotations_file : path to the annotation file.
 		  Aspect (B=BP,C=CC,M=MF), GO domain.
  		  Evidence_Code, evidence to be ignored.
		  organism : organinsm corresponding to the annotations	
 * OUTPUT: 
	the methods generates the following files:
  	Annotation_table_reduced, table in which each record represent the association between a GO term and a gene with the specified evidence
	classi_GO, set of GO term IDs  found during the parsing
	geni, set of the found gene IDs 
public class ParsingAnnotatioFile {
	
	public void storeAnnotations(String cod_dec_ev,String versione,String organismo,String path_to_annotations_file,String Aspect,ArrayList<String> Evidence_Code){
		/* Parsing annotation file: analizza file annotazioni e costrusce la corrispondente tabella: Annotation_table_reduced.
	     * Nella tabella vengono inserite solo le tuple relative ad Aspect indicato ed Evidence_Code 
	     * diverse da quelle indicate.*/
	    System.out.println("Parsing Annotation file...");
	    /* L'oggetto java che effettua il parsing del file delle annotazioni  Annotation_parser_reduced.
	     * Questo oggetto mette a disposizione il metodo build_table_mod() che riceve come parametri Aspect(dominio) e 
	     * lista di evidence_code da ignorare, e crea la tabella Annotation_table_reduced */
		Annotation_parser_reduced Parser_reduced = new Annotation_parser_reduced(path_to_annotations_file);
		Parser_reduced.build_table_mod(Aspect, Evidence_Code);
		System.out.println("End!");
		
		String dom_ute;
		if(Aspect.startsWith("P"))dom_ute="BP";
		else if(Aspect.startsWith("C"))dom_ute="CC";
		else dom_ute="MF";
		
		
		//controllo se nella cartella versione_OBO c' gi la cartella relativa all'organismo.
		File f = new File ("./workspace/sim_calc/"+versione+"/"+organismo);
		boolean esiste = f.exists();
		
		if(!esiste) {
			System.out.println("la directory: "+versione+"/"+organismo+" NON ESISTE");
			System.out.println("creo tutte le directory e sottodirectory...");
			//creo directory organismo dentro directory versione_OBO
			File directory = new File("./workspace/sim_calc/"+versione+"/"+organismo+"/");
		    if (!directory.mkdir()) {
		       System.out.println("Impossibile creare la directory "+versione+"/"+organismo);
		    }
		    
		    //creo directory versione organismo
		    File directory2 = new File ("./workspace/sim_calc/"+versione+"/"+organismo+"/GAF_2011-01-01/");
		    if (!directory2.mkdir()) {
			       System.out.println("Impossibile creare la directory "+versione+"/"+organismo+"/GAF_2011-01-01");
			    }
		    
		    //creo directory ramo
		    File directory3 = new File ("./workspace/sim_calc/"+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/");
		    if (!directory3.mkdir()) {
			       System.out.println("Impossibile creare la directory "+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute);
			    }
		    
		    //creo directory evidence associate al ramo
		    File directory4 = new File ("./workspace/sim_calc/"+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/"+cod_dec_ev+"/");
		    if (!directory4.mkdir()) {
			       System.out.println("Impossibile creare la directory "+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/"+cod_dec_ev);
			    }
		    System.out.println("fatto!");
		}
		else{//cartella organismo esiste
			System.out.println("la directory: "+versione+"/"+organismo+" ESISTE");
			//controllo se nella cartella organismo c' gi la cartella relativa al ramo.
			File f2 = new File ("./workspace/sim_calc/"+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute);
			boolean esiste2 = f2.exists();
			if(!esiste2){
				System.out.println("la directory: "+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+" NON ESISTE");
				System.out.println("creo la directory e tutte le sotto directory...");
				//creo directory ramo
			    File directory5 = new File ("./workspace/sim_calc/"+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/");
			    if (!directory5.mkdir()) {
				       System.out.println("Impossibile creare la directory "+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/");
				    }
			  //creo directory evidence associate al ramo
			    File directory6 = new File ("./workspace/sim_calc/"+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/"+cod_dec_ev+"/");
			    if (!directory6.mkdir()) {
				       System.out.println("Impossibile creare la directory "+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/"+cod_dec_ev);
				    }
			    System.out.println("fatto!");
			}
			else{ //la directory ramo esiste
				System.out.println("la directory: "+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+" ESISTE");
				//controllo se esiste la directory evidence associate al ramo
				File f3 = new File ("./workspace/sim_calc/"+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/"+cod_dec_ev);
				boolean esiste3 = f3.exists();
				if(!esiste3){//la directory sulle evidence non esiste
					System.out.println("la directory: "+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/"+cod_dec_ev+" NON ESISTE");
					System.out.println("la creo...");
					//creo directory evidence associate al ramo
				    File directory7 = new File ("./workspace/sim_calc/"+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/"+cod_dec_ev+"/");
				    if (!directory7.mkdir()) {
					       System.out.println("Impossibile creare la directory "+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/"+cod_dec_ev);
					    }
				    System.out.println("fatto!");
				}
				
			}
		}
		//a questo punto il path relativo alle nuove strutture dati  stato creato
		
		StoreFile("./workspace/sim_calc/"+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/"+cod_dec_ev+"/Annotation_table_reduced", Parser_reduced.Annotations_Table_reduced);
		StoreFile("./workspace/sim_calc/"+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/"+cod_dec_ev+"/classi_GO", Parser_reduced.classi_GO);
		StoreFile("./workspace/sim_calc/"+versione+"/"+organismo+"/GAF_2011-01-01/"+dom_ute+"/"+cod_dec_ev+"/geni", Parser_reduced.geni);
		
		
		ArrayList<FileIn> lista_file = new ArrayList<FileIn>();
		ObjectInputStream ois_file;
		System.out.println("carico lista file per aggiornamento...");
		try{
			ois_file = new ObjectInputStream(new FileInputStream("./workspace/sim_calc/lista_file"));
			lista_file = (ArrayList<FileIn>)ois_file.readObject();
		}
		catch(Exception e_f){
			System.out.println("errore caricamento lista_file");
		}
		System.out.println("fatto!");
		
		boolean file_found = false;
		for(FileIn fi: lista_file){//scorro tutti i file
			if(fi.versione_OBO.compareTo(versione)==0){
				if(fi.organismo.compareTo(organismo)==0){
					file_found=true;
					if(fi.dom_evidence.keySet().contains(dom_ute)){
						fi.dom_evidence.get(dom_ute).add(cod_dec_ev);
					}
					else{
						ArrayList<String> ev_asso = new ArrayList<String>();
						ev_asso.add(cod_dec_ev);
						fi.dom_evidence.put(dom_ute, ev_asso);
					}
				}
			}
		}//fine scorre tutti file
		
		if(!file_found){//il file che cerchiamo non c', lo creiamo e aggiorniamo lista file
			FileIn nuovo_file = new FileIn();
			nuovo_file.versione_OBO = versione;
			nuovo_file.organismo = organismo;
			
			ArrayList<String> lista_domini = new ArrayList<String>();
			lista_domini.add("CC");lista_domini.add("MF");lista_domini.add("BP");
			nuovo_file.domini = lista_domini;
			
			Hashtable<String, ArrayList<String>> dom_ev = new Hashtable<String, ArrayList<String>>();
			ArrayList<String> ev_asso = new ArrayList<String>();
			ev_asso.add(cod_dec_ev);
			dom_ev.put(dom_ute, ev_asso);
			nuovo_file.dom_evidence = dom_ev;
						
			lista_file.add(nuovo_file);
		}
		
		//memorizzo lista file aggiornato (o con un nuovo record o con aggiornamenti sui campi di un record)
		StoreFile("./workspace/sim_calc/lista_file",lista_file);
		
	}
	
		
	
	public static void StoreFile(String FileName, Object structure){
		System.out.println("Storing "+FileName+"...");
		ObjectOutputStream oss;
        try{
            oss = new ObjectOutputStream(new FileOutputStream(FileName));
            oss.writeObject(structure);
            oss.close();
        }
        catch(Exception e1){
                System.out.println("error during store "+FileName);
                e1.printStackTrace();
        }
        System.out.println("Done!");
	}

}
