package obo;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

public class Get_JIANG {
	
	public void get_jiang(String Path){
		System.out.println("Calcolo JIANG...");
		ArrayList<String> terms_for_LCA = new ArrayList<String>();
		ObjectInputStream ois11;
		System.out.println("start load terms_for_LCA...");
		try{
			ois11 = new ObjectInputStream(new FileInputStream(Path+"/terms_for_LCA"));
			terms_for_LCA = (ArrayList<String>) ois11.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading terms_for_LCA");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		//carico RESNIK
		double[][] RESNIK = new double[terms_for_LCA.size()][terms_for_LCA.size()];
		ObjectInputStream ois13;
		System.out.println("start load RESNIK...");
		try{
			ois13 = new ObjectInputStream(new FileInputStream(Path+"/RESNIK"));
			RESNIK = (double[][]) ois13.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading RESNIK");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		double max_resnik=0.0;
		for(int r=0;r<RESNIK.length;r++){
			for(int c=0;c<RESNIK[0].length;c++){
				if(RESNIK[r][c]>max_resnik)max_resnik=RESNIK[r][c];
			}
		}
		
		//Resnik=Resnik/max_Resnik;
		for(int r=0;r<RESNIK.length;r++){
			for(int c=0;c<RESNIK[0].length;c++){
				RESNIK[r][c] = (RESNIK[r][c]/max_resnik);
			}
		}
		
		//diagtemp=diag(RESNIK);
		double[] diagtemp = new double[RESNIK.length];
		for(int o=0;o<RESNIK.length;o++){
			diagtemp[o] = RESNIK[o][o];
		}
		
		//JIANG=1+ 2*RESNIK-repmat(diagtemp,1,N)-repmat(diagtemp',N,1)
		double[][] JIANG = new double[RESNIK.length][RESNIK[0].length];
		double[][] repmat1= new double[RESNIK.length][RESNIK[0].length];
		double[][] repmat2= new double[RESNIK.length][RESNIK[0].length];
		for(int r=0;r<repmat1.length;r++){
			for(int c=0;c<repmat1[0].length;c++){
				repmat1[r][c]=diagtemp[r];
			}
		}
		for(int r=0;r<repmat2.length;r++){
			for(int c=0;c<repmat2[0].length;c++){
				repmat2[r][c]=diagtemp[c];
			}
		}
		
		for(int r=0;r<JIANG.length;r++){
			for(int c=0;c<JIANG[0].length;c++){
				JIANG[r][c] =(1+ (2*RESNIK[r][c])-(repmat1[r][c])-(repmat2[r][c]) );
			}
		}
		
		StoreFile(Path+"/JIANG", JIANG);
		System.out.println("Fine calcolo JIANG!");
	}
	
	public static void StoreFile(String FileName, Object structure){
		System.out.println("Storing "+FileName+"...");
			ObjectOutputStream oss;
	        try{
	            oss = new ObjectOutputStream(new FileOutputStream(FileName));
	            oss.writeObject(structure);
	            oss.close();
	        }
	        catch(Exception e1){
	                System.out.println("error during store "+FileName);
	                e1.printStackTrace();
	        }
	        System.out.println("Done!");
		}

}
