package obo;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Hashtable;

import annotation.Annotation_record_reduced;

/* The method get_tree_p(Aspect) corresponds to TREE_P.m e a TREE_P_NoBranch.m of the original MATLAB code
 * Calcola GO_GENE (TREE_P) e GO_GENE_NoBranch (TREE_P_NoBranch).
 * INPUT: Aspect 
 * OUTPUT: genera i seguenti file.
 * 		GO_GENE, corresponding to TREE_P in MATLAB code. Hashtable containing for each GO term the number 
			annotated genes weighted by the up-degree of the term.		
		GO_GENE_NoBranch, corresponding to TREE_P_NoBranch in MATLAB code. the same as GO_GENE but the number of annotation
			 is not weighted by the updegree
*/
public class Get_TREE_P {
	
	public void get_tree_p (String Path_version,String Path,String Aspect) throws FileNotFoundException{
		System.out.println("Calcolo TREE_P e TREE_P_NoBranch");
		/* GO_GENE corrisponde al TREE_P del codice di Paccanaro, in questa hashtable vengono memorizzati i termini
		 * con il corrispondente numero di geni annotati. Il numero di geni annotati viene calcolato escludendo i geni
		 * annotati con evidence uguali a quelle da ignorare. Inoltre, questo valore viene pesato con l'updegree del termine,
		 * ossia con il numero di padri del termine.
		 * GO_GENE_NoBranch viene costruito allo stesso modo di GO_GENE e corrisponde al TREE_P_NoBranch del codice 
		 * Paccanaro.La differenza tra GO_GENE e GO_GENE_NoBranch  che in GO_GENE_NoBranch il numero di geni annoati
		 * con un termine non viene pesato con l'updegree del termine stesso.*/
		Hashtable<String, Double> GO_GENE = new Hashtable<String, Double>();
		Hashtable<String, Double> GO_GENE2 = new Hashtable<String, Double>();//hash temporanea utilizzata nel calcolo di GO_GENE_NoBranch
		Hashtable<String, Double> GO_GENE_NoBranch = new Hashtable<String, Double>();
		Hashtable<String, ArrayList<String>> GO_listGENE = new Hashtable<String, ArrayList<String>>();//contiene per ogni termine la lista dei geni annotati, a differenza delle altre hashtable, qui memorizziamo l'ID di ogni gene annoato e non il numero complessivo
		
		ArrayList<String>classi_GO = new ArrayList<String>();
		ObjectInputStream ois;
		System.out.println("start load classi_GO...");
		try{
		    ois = new ObjectInputStream(new FileInputStream(Path+"/classi_GO"));
		    classi_GO = (ArrayList<String>) ois.readObject();		          
		}
		catch(Exception e){
			System.out.println("error during loading classi_GO");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		ArrayList<Annotation_record_reduced>Annotations_Table_reduced = new ArrayList<Annotation_record_reduced>();
	     ObjectInputStream ois2;
	     System.out.println("start load annotation table...");
	      try{
	          ois2 = new ObjectInputStream(new FileInputStream(Path+"/Annotation_table_reduced"));
	          Annotations_Table_reduced = (ArrayList<Annotation_record_reduced>) ois2.readObject();
	          /*for(int i=0;i<10;i++){
	        	  System.out.println(Annotation_table_reduced.get(i).c2_DB_Object_ID + " " + Annotation_table_reduced.get(i).c5_GO_ID + " " + Annotation_table_reduced.get(i).c7_Evidence_code + " " + Annotation_table_reduced.get(i).c9_Aspect);
	          }*/
	          
	      }
	      catch(Exception e){
	          System.out.println("error during loading Annotation_table_reduced");
	          e.printStackTrace();
	      }
	      System.out.println("done!");
	      
	      ArrayList<Tupla_Tabella_GO>TreeXX = new ArrayList<Tupla_Tabella_GO>();
	      Hashtable<String,ArrayList<String>> UpXX = new Hashtable<String, ArrayList<String>>();
	      Hashtable<String,ArrayList<String>> DownXX = new Hashtable<String, ArrayList<String>>();
	      if(Aspect.compareTo("C")==0){
	    	  ObjectInputStream ois1;
	    	  System.out.println("start load ontology...");
	    	  try{
		          ois1 = new ObjectInputStream(new FileInputStream(Path_version+"/TreeCC"));
		          TreeXX = (ArrayList<Tupla_Tabella_GO>) ois1.readObject();
		      }
		      catch(Exception e){
		          System.out.println("error during loading TreeCC");
		          e.printStackTrace();
		      }
	    	  System.out.println("done!");
	    	  
	    	  ObjectInputStream ois1a;
	    	  System.out.println("start load UpCC...");
	    	  try{
		          ois1a = new ObjectInputStream(new FileInputStream(Path_version+"/UpCC"));
		          UpXX = (Hashtable<String, ArrayList<String>>) ois1a.readObject();
		      }
		      catch(Exception e){
		          System.out.println("error during loading UpCC");
		          e.printStackTrace();
		      }
	    	  System.out.println("done!");
	    	  
	    	  ObjectInputStream ois1b;
	    	  System.out.println("start load DownCC...");
	    	  try{
		          ois1b = new ObjectInputStream(new FileInputStream(Path_version+"/DownCC"));
		          DownXX = (Hashtable<String, ArrayList<String>>) ois1b.readObject();
		      }
		      catch(Exception e){
		          System.out.println("error during loading DownCC");
		          e.printStackTrace();
		      }
	    	  System.out.println("done!");
	      }
	      
	      else if(Aspect.compareTo("P")==0){
	    	  ObjectInputStream ois1;
	    	  System.out.println("start load ontology...");
	    	  try{
		          ois1 = new ObjectInputStream(new FileInputStream(Path_version+"/TreeBP"));
		          TreeXX = (ArrayList<Tupla_Tabella_GO>) ois1.readObject();
		      }
		      catch(Exception e){
		          System.out.println("error during loading TreeBP");
		          e.printStackTrace();
		      }
	    	  System.out.println("done!");
	    	  
	    	  ObjectInputStream ois2a;
	    	  System.out.println("start load UpBP...");
	    	  try{
		          ois2a = new ObjectInputStream(new FileInputStream(Path_version+"/UpBP"));
		          UpXX = (Hashtable<String, ArrayList<String>>) ois2a.readObject();
		      }
		      catch(Exception e){
		          System.out.println("error during loading UpBP");
		          e.printStackTrace();
		      }
	    	  System.out.println("done!");
	    	  
	    	  ObjectInputStream ois2b;
	    	  System.out.println("start load DownBP...");
	    	  try{
		          ois2b = new ObjectInputStream(new FileInputStream(Path_version+"/DownBP"));
		          DownXX = (Hashtable<String, ArrayList<String>>) ois2b.readObject();
		      }
		      catch(Exception e){
		          System.out.println("error during loading DownBP");
		          e.printStackTrace();
		      }
	    	  System.out.println("done!");
	    	  
	      }
	      
	      else if(Aspect.compareTo("F")==0){
	    	  ObjectInputStream ois1;
	    	  System.out.println("start load ontology...");
	    	  try{
		          ois1 = new ObjectInputStream(new FileInputStream(Path_version+"/TreeMF"));
		          TreeXX = (ArrayList<Tupla_Tabella_GO>) ois1.readObject();
		      }
		      catch(Exception e){
		          System.out.println("error during loading TreeMF");
		          e.printStackTrace();
		      }
	    	  System.out.println("done!");
	    	  
	    	  ObjectInputStream ois3a;
	    	  System.out.println("start load UpMF...");
	    	  try{
		          ois3a = new ObjectInputStream(new FileInputStream(Path_version+"/UpMF"));
		          UpXX = (Hashtable<String, ArrayList<String>>) ois3a.readObject();
		      }
		      catch(Exception e){
		          System.out.println("error during loading UpMF");
		          e.printStackTrace();
		      }
	    	  System.out.println("done!");
	    	  
	    	  ObjectInputStream ois3b;
	    	  System.out.println("start load DownMF...");
	    	  try{
		          ois3b = new ObjectInputStream(new FileInputStream(Path_version+"/DownMF"));
		          DownXX = (Hashtable<String, ArrayList<String>>) ois3b.readObject();
		      }
		      catch(Exception e){
		          System.out.println("error during loading DownMF");
		          e.printStackTrace();
		      }
	    	  System.out.println("done!");
	      }
		
	      ArrayList<String> Lista = new ArrayList<String>();
	      for(Tupla_Tabella_GO at: TreeXX){
			String go = at.id;
			Lista.add(go);
			ArrayList<String> geni_distinti = new ArrayList<String>();//conterr la lista dei geni distinti annotati con il termine
			Double count=0.0;//conta il numero di geni distinti annotati con il termine in questione(go)
			for(Annotation_record_reduced arr : Annotations_Table_reduced){//scorre le tuple della tabella ottenuta dal parsing dell'annotation file
				if(arr.c5_GO_ID.compareTo(go)==0){//trovata tupla relativa al termine in questione(go)
					if(!geni_distinti.contains(arr.c2_DB_Object_ID)){//se il gene annotato con il termine(go) non  gia nella lista del geni distinti,allora lo aggiungo alla lista e incremento count
						geni_distinti.add(arr.c2_DB_Object_ID);
						count++;
					}
				}
			}
			GO_GENE.put(go, count);//inserisco in GO_GENE(TREE_P) il numero di geni annotati con il termine
			GO_GENE2.put(go, count);//inserisco in GO_GENE2 il numero di geni annotati con il termine(mi seriv per calcolare GO_GENE_NoBranch
			GO_listGENE.put(go, geni_distinti);//inserisco in GO_listGENE gli ID dei geni annotati con il termine
		}
			
		/* Per i termini che non hanno geni annotati che rispettano la condizione precedente
		 * (devono essere annotati con evidence diverse da quelle da ignorare) o che non hanno geni annotati,
		 *  inserisco uno 0 in GO_GENE (TREE_P) e in tutte le altre hashtable. */
		for(Tupla_Tabella_GO tupl : TreeXX){
			if(GO_GENE.containsKey(tupl.id))continue;
			else {
				GO_GENE.put(tupl.id, 0.0);
				GO_GENE2.put(tupl.id, 0.0);
				ArrayList<String> vuoto = new ArrayList<String>();
				GO_listGENE.put(tupl.id, vuoto);
			}
		}
			
		/* inizializzo GO_GENE_NoBranch a tutti -1 */
		for(Tupla_Tabella_GO ty : TreeXX){
			GO_GENE_NoBranch.put(ty.id, -1.0);
		}
		
		System.out.println("Lista size = "+Lista.size());
		//ordino gli ID in base al loro valore numerico
		ArrayList<String> termini_ordinati = new ArrayList<String>();
		Hashtable<String, Integer> num = new Hashtable<String, Integer>();
		Hashtable<Integer,String> num_inv = new Hashtable<Integer, String>();
		for(String te:Lista){
			int num_te = Integer.parseInt(te.substring(3));
			num.put(te, num_te);
			num_inv.put(num_te, te);
		}
		int[] for_sort = new int[Lista.size()];
		int ci=0;
		for(String term:num.keySet()){
			for_sort[ci] = num.get(term);
			ci++;
		}
		Arrays.sort(for_sort);
		for(int p=0;p<for_sort.length;p++){
			termini_ordinati.add(num_inv.get(for_sort[p]));
		}
		System.out.println("termini_ordinati size = "+termini_ordinati.size());
		
		
		/* Calcolo Updegree e Downdegree per ogni termine, sono Hashtable che contengono id termine-numero padri, e 
		 * id termine - numero figli, rispettivamente.Ci serviranno per il calcolo di TREE_P e TREE_P_NoBranch */
		Hashtable<String, Integer> GO_Updegree = new Hashtable<String, Integer>();
		Hashtable<String, Integer> GO_Downdegree = new Hashtable<String, Integer>();
		for(String id: UpXX.keySet()){
			int count_padri = 0;
			for(String pad:UpXX.get(id)){
				if(!Lista.contains(pad))continue;
				else count_padri++;
			}
			int num_parent = count_padri;
			GO_Updegree.put(id, num_parent);
			
			int num_child = DownXX.get(id).size();
			GO_Downdegree.put(id, num_child);
		}
			
		PrintWriter out1 = new PrintWriter(Path+"/Updegree.txt");
	    PrintWriter out2 = new PrintWriter(Path+"/Downdegree.txt");
	    PrintWriter out3 = new PrintWriter(Path+"/Lista.txt");
	    int x=0;
	    for (String s: termini_ordinati){  
	    	x++;
	    	out3.println(x+" - "+s);
	    }
	    out3.close();
	    
	    for (String s: termini_ordinati){    	
	    	out1.println(GO_Updegree.get(s));
	    }
	    for (String s: termini_ordinati){    	
	    	out2.println(GO_Downdegree.get(s));
	    }
		
	    out1.close();
	    out2.close();
		
		/* trovo root, ossia il termine che ha Updegree=0,ossia non ha padri. 
		 * Ci servir per calcolare TREE_P e TREE_P_NoBranch. */
		String id_root="-";
		for(String go_id : GO_Updegree.keySet()){
			if(GO_Updegree.get(go_id)==0){
				id_root=go_id;
				break;
			}
		}
		System.out.println("root = "+id_root);
		
		/* imposto updegree root = 1.Queste operazioni seguono le corrispondenti dei file di Paccanaro(TREE_P.m e TREE_P_NoBranch.m) */
		if(id_root.startsWith("-")) System.out.println("ERRORE root non valida.");
		else{
			GO_Updegree.remove(id_root);
			GO_Updegree.put(id_root, 1);
		}
		
		/* cerco i termini foglia, ossia i termini che hanno Downdegree=0.Dove Downdegree  il numero di figli. */
		ArrayList<String> id_leaf = new ArrayList<String>();
		for(String go_id: GO_Downdegree.keySet()){
			if(GO_Downdegree.get(go_id)==0) id_leaf.add(go_id);
		}
		
		/* in corrispondenza delle foglie inserisco il num di geni annotati (solo per GO_GENE_NoBranch, corrispondente al TREE_P_NoBranch.m) */
		for(String fg : id_leaf){
			GO_GENE_NoBranch.remove(fg);
			GO_GENE_NoBranch.put(fg, GO_GENE.get(fg));
		}
			
		/* visitati sar un hashtable che conterr un 1 incorrispondenza degli id 
		 * dei termini gi visitati durante il Down Random Walk(serve sempre per il calcolo di TREE_P e TREE_P_Nobranch,
		 * inizialmente tutti i termine avranno valore 0, in quanto non ancora visitati. 
		*/
		Hashtable<String, Integer> visitati = new Hashtable<String, Integer>();
		for(Tupla_Tabella_GO tt:TreeXX){
			visitati.put(tt.id, 0);
		}
		
		// All'interno di "visitati", in corrispondenza dei termini foglia, inserisco un 1.
		for(String fogl : id_leaf){
			visitati.remove(fogl);
			visitati.put(fogl, 1);
		}	
		
		/* GO_GENE (TREE_P pesato) viene effettivamente calcolato tramite la funzione AssignValue, definita di seguito. */
		System.out.println("Calcolo TREE_P pesato");
		Double Re = AssignValue(id_root,TreeXX,visitati,GO_GENE,GO_Updegree);
		System.out.println("fatto!");
		
		/* GO_GENE_NoBranch (TREE_P_NoBranch) viene effettivamente calcolato attraverso la finzione AssignValueNoBranch,definita di seguito. */
		System.out.println("Calcolo TREE_P_NoBranch");
		AssignValueNoBranch(id_root,GO_GENE2,TreeXX,GO_GENE_NoBranch,GO_listGENE);
		System.out.println("fatto!");
		
		System.out.println("dimensione GO_GENE = "+GO_GENE.size());
		System.out.println("dimensione GO_GENE_NoBranch = "+GO_GENE_NoBranch.size());
		
		
		StoreFile(Path+"/GO_GENE", GO_GENE);
		StoreFile(Path+"/GO_GENE_NoBranch",GO_GENE_NoBranch);
		
		ArrayList<String> terms_for_LCA = new ArrayList<String>();//termini che hanno valore in GO_GENE_NoBranch>0.
		Hashtable<String, Double> TREE_P_filtrato = new Hashtable<String, Double>();//conterr il sottoinsieme dei termini in GO_GENE_NoBranch che hanno valore>0. 
		for(String st : GO_GENE_NoBranch.keySet()){//scorre TREE_P_NoBranch
			if(GO_GENE_NoBranch.get(st)>0.0) {
				TREE_P_filtrato.put(st, GO_GENE_NoBranch.get(st));
				terms_for_LCA.add(st);
			}
		}
		System.out.println("dimensione terms_for_LCA = "+terms_for_LCA.size());
		
		
		
		
	    PrintWriter out18 = new PrintWriter(Path+"/go_gene.txt");
	    PrintWriter out19 = new PrintWriter(Path+"/go_gene_NoBranch.txt");
	    for (String st: termini_ordinati) {
	    	out18.println("GO_GENE["+st+"] = "+GO_GENE.get(st));
	    }
	    out18.close();
	    
	    for (String st: termini_ordinati) {
	    	out19.println("GO_GENE_NoBranch["+st+"] = "+GO_GENE_NoBranch.get(st));
	    }
	    out19.close();
	}
	
	public static Double AssignValue(String id,ArrayList<Tupla_Tabella_GO> TreeXX, Hashtable<String, Integer> visitati, Hashtable<String, Double> GO_GENE,Hashtable<String, Integer> GO_Updegree){
		 
		/* Down conterr i figli del termini con id uguale a quello passato come paramentro */
		ArrayList<String> Down = new ArrayList<String>();
		/* prendo id dei figli dalla tabella TreeCC */
		for(Tupla_Tabella_GO tup: TreeXX ){
			if(tup.id.compareTo(id)==0){
				for(String figlio : tup.childs){
					Down.add(figlio);
				}
			}
		}
		/* ---- */
		
		Double Re=0.0;
		for(int i=0;i<Down.size();i++){//scorro i figli
			
			String j = Down.get(i);//j = id del figlio
			if(!visitati.containsKey(j))continue;
			//System.out.println("figlio = "+j);
			if(visitati.get(j)==0){
				AssignValue(j,TreeXX,visitati,GO_GENE,GO_Updegree);
			}
			if(visitati.get(j)==0)System.out.println("ERRORE in AssignValue.");
			
			Re = Re + GO_GENE.get(j)/GO_Updegree.get(j) ;
		}
		
		visitati.remove(id);
		visitati.put(id, 1);
		Double old_GO_GENE = GO_GENE.get(id);
		GO_GENE.remove(id);
		Double new_num = ( old_GO_GENE+Re );
		GO_GENE.put(id, new_num);
		
		return Re;
		
	}
	
	public static void AssignValueNoBranch(String id,Hashtable<String, Double> GO_GENE2,ArrayList<Tupla_Tabella_GO> TreeXX, Hashtable<String, Double> GO_GENE_NoBranch,Hashtable<String, ArrayList<String>> GO_listGENE){
		
		
		/* Down conterr i figli del termini con id uguale a quello passato come paramentro */
		ArrayList<String> Down = new ArrayList<String>();
		/* prendo id dei figli dalla tabella TreeCC */
		for(Tupla_Tabella_GO tup: TreeXX ){
			if(tup.id.compareTo(id)==0){
				for(String figlio : tup.childs){
					Down.add(figlio);
				}
			}
		}
		/* ---- */
		
		for(int i=0;i<Down.size();i++){//scorro i figli
			
			String j = Down.get(i);//j = id del figlio
			if(!GO_GENE_NoBranch.containsKey(j))continue;
			if(GO_GENE_NoBranch.get(j)==-1.0){
				AssignValueNoBranch(j,GO_GENE2,TreeXX,GO_GENE_NoBranch,GO_listGENE);
			}
			
			if(GO_listGENE.get(j).size()==0)continue;
			for(String cf : GO_listGENE.get(j)){
				if(!GO_listGENE.get(id).contains(cf)){
					GO_listGENE.get(id).add(cf);
				}
			}
		}
		
		GO_GENE_NoBranch.remove(id);
		GO_GENE_NoBranch.put(id, (GO_listGENE.get(id).size()*1.0));
			
	}
	
	public static void StoreFile(String FileName, Object structure){
		System.out.println("Storing "+FileName+"...");
		ObjectOutputStream oss;
        try{
            oss = new ObjectOutputStream(new FileOutputStream(FileName));
            oss.writeObject(structure);
            oss.close();
        }
        catch(Exception e1){
                System.out.println("error during store "+FileName);
                e1.printStackTrace();
        }
        System.out.println("Done!");
	}

}
