package obo;

import java.io.FileInputStream;
import java.io.ObjectInputStream;
import java.util.ArrayList;

/**
 * OBOReaderDriver is a Driver class.
   the input id the Obo file downloaded by the Gene Ontology web site and build the corresponding ontology
   It uses the class OBOReader
 */
public class OBOReaderDriver
{

    public static void main(String[] args)
    {
    	/* L'Oggetto OBOReader mette a disposizione il metodo buildHier() che
    		permette di costruire la gerarchia dei termini */
        /*
    	OBOReader or = new OBOReader("current.obo");
        or.buildHier();
        */
    	
    		OBOReader onto = null;
	    	ObjectInputStream ois_o;
		    System.out.println("start load go_ontology...");
		    try{
		          ois_o = new ObjectInputStream(new FileInputStream("release_01-01-2011/go_ontology"));
		          onto = (OBOReader) ois_o.readObject();
		      }
		      catch(Exception e){
		          System.out.println("error during loading go_ontology");
		          e.printStackTrace();
		      }
		    System.out.println("done!");
        /* ogni termine della gerarchia  un oggetto di tipo TermInfo.
         	invocando il metodo getTerm(id del termine) sull'oggetto OBOReader
         	viene restituito l'oggetto TermInfo relativo al termine indicato. */
        TermInfo term = onto.getTerm("GO:0000001");
        
        /* TermInfo mette a disposizione alcuni metodi get per 
         * reperire info sul termine.
         * Di seguito stampiamo nome, namespace e definizione del termine  */
       // System.out.println("Termine: "+term.getName());
       // System.out.println("Namespace: "+term.getNamespace());
       // System.out.println("Definizione: "+term.getDefinition());
        
        /* il metodo getChildren() restituisce un ArrayList che contiene
         *  i figli del termine sul quale viene invocato */
        ArrayList childrenIDs = term.getChildren();
        
        /*  di seguito stampiamo le info sui termini figli  */
        for (int i=0; i < childrenIDs.size(); i++)
        {
            String childID = (String) childrenIDs.get(i);
            TermInfo childTerm = onto.getTerm(childID);
            System.out.println("Termine Figlio: "+childID);
        }
        
        /* il metodo getParents() restituisce un ArrayList che contiene
         *  i padri del termine sul quale viene invocato */
        ArrayList parentsIDs = term.getParents();
        
        /*  di seguito stampiamo le info sui termini padri  */
        for (int i=0; i < parentsIDs.size(); i++)
        {
            String parentID = (String) parentsIDs.get(i);
            TermInfo parentTerm = onto.getTerm(parentID);
          //  System.out.println("Termine Padre: "+parentTerm);
        }
        
        /* l'oggetto OBOReader fornisce i metodi getList(termine,lista_vuota)
         * e getAncestorList(termine,lista_vuota) che restituiscono 
         * rispettivamente i discendenti e gli antenati del temine indicato
         * all'interno delle liste_vuote fornite.  */
        String discendenti = new String();
        System.out.println("Discendenti: "+onto.getList(term,discendenti));
        
        String antenati = new String();
        antenati = onto.getAncestorList(term,antenati);
        System.out.println("Antenati: "+antenati);
        System.out.println("----------------------");
        
    }

}
