package obo;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Hashtable;

import annotation.Annotation_parser_reduced;
import annotation.Annotations_record;
import annotation.Sim_record;

public class Sperim2MF_rw {
	
	public static void main(String[] args) {
		System.out.println("Start Sperim2...");
		ArrayList<Sim_record> GENE_SIM = new ArrayList<Sim_record>();
		ObjectInputStream ois;
		System.out.println("start load GENE_SIM...");
		try{
			ois = new ObjectInputStream(new FileInputStream("correlazione/GENE_SIM"));
		    GENE_SIM = (ArrayList<Sim_record>) ois.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading GENE_SIM");
			e.printStackTrace();
		}
		System.out.println("done!");
		System.out.println("GENE_SIM size = "+GENE_SIM.size());
		
		
		/* carico file go_ontology corrispondente all'ontologia parsata */
		OBOReader go_ontology = null;
		ObjectInputStream ois7;
		System.out.println("start load go_ontology...");
		try{
			ois7 = new ObjectInputStream(new FileInputStream("release_01-01-2011/go_ontology"));
		    go_ontology = (OBOReader) ois7.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading go_ontology");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		/* carico ontologia relativa al dominio TreeCC */
		ArrayList<Tupla_Tabella_GO>TreeMF = new ArrayList<Tupla_Tabella_GO>();
	    ObjectInputStream ois2;
	    System.out.println("start load TreeMF...");
	    try{
	          ois2 = new ObjectInputStream(new FileInputStream("release_01-01-2011/TreeMF"));
	          TreeMF = (ArrayList<Tupla_Tabella_GO>) ois2.readObject();
	      }
	      catch(Exception e){
	          System.out.println("error during loading TreeMF");
	          e.printStackTrace();
	      }
	    System.out.println("done!");
	    
	    Hashtable<String, ArrayList<String>>UpMF = new Hashtable<String, ArrayList<String>>();
	    ObjectInputStream ois5;
	    System.out.println("start load UpMF...");
	    try{
	          ois5 = new ObjectInputStream(new FileInputStream("release_01-01-2011/UpMF"));
	          UpMF = (Hashtable<String, ArrayList<String>>) ois5.readObject();
	          
	      }
	      catch(Exception e){
	          System.out.println("error during loading UpMF");
	          e.printStackTrace();
	      }
	    System.out.println("done!");
	    
	    Hashtable<String, ArrayList<String>>DownMF = new Hashtable<String, ArrayList<String>>();
	    ObjectInputStream ois6;
	    System.out.println("start load DownMF...");
	    try{
	          ois6 = new ObjectInputStream(new FileInputStream("release_01-01-2011/DownMF"));
	          DownMF = (Hashtable<String, ArrayList<String>>) ois6.readObject();
	          
	      }
	      catch(Exception e){
	          System.out.println("error during loading DownMF");
	          e.printStackTrace();
	      }
	    System.out.println("done!");
	    
	    String Aspect = "F";
		ArrayList<String>  Evidence_Code = new ArrayList<String>();//contiene gli evidence code da ignorare
		Evidence_Code.add("IEA");
		Evidence_Code.add("NR");
		Evidence_Code.add("ND");
		Evidence_Code.add("IC");
	    /* parsing del file delle annotazioni relativo ad uno specifico corpus (Saccharomyce)
	     * IL file non  quello di Paccanaro ma l'ultimo pubblicato da SGD in data 5/11/2011 */
	    Annotation_parser_reduced apr = new Annotation_parser_reduced("gene_association.sgd");
		apr.build_table_mod(Aspect, Evidence_Code);
		System.out.println("Anno_table_reduced size = "+apr.Annotation_Table.size());
		
		/* filtro i geni annotati con i termini del dominio CC */
		System.out.println("parsing annotation file, filtro annotazioni relative al dominio MF...");
		Hashtable <String, ArrayList<String>> geni_termini = new Hashtable<String, ArrayList<String>>();
		ArrayList<String> totale_termini = new ArrayList<String>();
		for(Annotations_record arr:apr.Annotation_Table){
			if(arr.c9_Aspect.compareTo("F")==0){//trovata tupla che associa un gene con un termine del dominio CC
				if(geni_termini.containsKey(arr.c3_DB_Object_Symbol)){
					if(geni_termini.get(arr.c3_DB_Object_Symbol).contains(arr.c5_GO_ID))continue;//il termine fa gi parte della lista dei termini annotati con quel gene
					//System.out.println("PRIMA geni-termini di "+arr.c3_DB_Object_Symbol+ "- dimensione = "+geni_termini.get(arr.c3_DB_Object_Symbol).size());
					geni_termini.get(arr.c3_DB_Object_Symbol).add(arr.c5_GO_ID);
					if(!totale_termini.contains(arr.c5_GO_ID))totale_termini.add(arr.c5_GO_ID);//se il termine non  presente nella lista totale dei termini GO appartenenti a CC annotati con un qualsiasi GENE appartenente al Saccharomyce, allora lo aggiungo. 
					//System.out.println("DOPO gene_termini di "+arr.c3_DB_Object_Symbol+" - dimensione = "+geni_termini.get(arr.c3_DB_Object_Symbol).size());
				}
				else{
					ArrayList<String> lista_termini_del_gene = new ArrayList<String>();
					lista_termini_del_gene.add(arr.c5_GO_ID);
					geni_termini.put(arr.c3_DB_Object_Symbol, lista_termini_del_gene);
					if(!totale_termini.contains(arr.c5_GO_ID))totale_termini.add(arr.c5_GO_ID);
				}
			}
		}
		System.out.println("fatto!");
		
		System.out.println("numero geni = "+geni_termini.size());
		
		//carico mapping_ID_Indici_BP
		Hashtable<String, Integer>mapping_ID_Indici = new Hashtable<String, Integer>();
	    ObjectInputStream ois8;
	    System.out.println("start load MATRCICI_MF/mapping_ID_Indici...");
	    try{
	          ois8 = new ObjectInputStream(new FileInputStream("release_01-01-2011/Saccharomyce/GAF_2011-01-01/MF/15-0/mapping_ID_Indici"));
	          mapping_ID_Indici = (Hashtable<String, Integer>) ois8.readObject();
	          
	      }
	      catch(Exception e){
	          System.out.println("error during loading MATRICI_MF/mapping_ID_Indici");
	          e.printStackTrace();
	      }
	    System.out.println("done!");
		
	    System.out.println("Carico RWLIN...");
	    double[][] RWRESNIK = new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
	    ObjectInputStream ois9;
	    System.out.println("start load MATRICI_MF/RWJIANG...");
	    try{
	          ois9 = new ObjectInputStream(new FileInputStream("release_01-01-2011/Saccharomyce/GAF_2011-01-01/MF/15-0/RWJIANG"));
	          RWRESNIK = (double[][]) ois9.readObject();
	          
	      }
	      catch(Exception e){
	          System.out.println("error during loading MATRICI_MF/RWJIANG");
	          e.printStackTrace();
	      }
	    System.out.println("done!");
	    //------------FINE CALCOLO RESNIK---------------------//
		
		/* per ogni record di GENE_SIM calcolo la corrispettiva similarit semantica */
		
		ArrayList<Sim_record> GENE_SIM_SEM_MF_RWRESNIK = new ArrayList<Sim_record>();//conterr le similarit semantiche
		ArrayList<Sim_record> GENE_SIM_SEQ_MF_RWRESNIK = new ArrayList<Sim_record>();
		for(Sim_record sr : GENE_SIM){//scorro coppie di geni nel file esterno
			String gene_a = sr.ID_GENE_A;//primo gene nella coppia
			//System.out.println("GENE_A = "+gene_a);
			String gene_b = sr.ID_GENE_B;//secondo gene nella coppia
			//System.out.println("GENE_B = "+gene_b);
			
			double max_sim=0.0;//conterr la similarit semantica tra i due geni che si stanno confrontando
			if(!geni_termini.containsKey(gene_a)){
				//System.out.println("MF non contiene il gene_a = "+gene_a);
				continue;
			}
			for(String te: geni_termini.get(gene_a)){//prendo termini annotati con il primo gene
				int ind_te = mapping_ID_Indici.get(te);//prendo indice termine nella matrice di Resnik
				if(!geni_termini.containsKey(gene_b)){
					//System.out.println("MF non contiene il gene_b = "+gene_b);
					continue;
				}
				for(String ot_te: geni_termini.get(gene_b)){//prendo termini secondo gene
					int ind_ot_te = mapping_ID_Indici.get(ot_te);//prendo indice termine nella matrice Resnik
					if(RWRESNIK[ind_te][ind_ot_te]>max_sim)max_sim=RWRESNIK[ind_te][ind_ot_te];//fra tutte le similarit prendo la massima
				}
			}
			Sim_record sm = new Sim_record();//creo il nuovo record che andr ad aggiungere a GENE_SIM_SEM
			Sim_record sm_GENE_SIM_MF_RWResnik = new Sim_record();//RECORD CHE AGGIUNGERO GENE_SIM_SEQ
			sm_GENE_SIM_MF_RWResnik.ID_GENE_A = sr.ID_GENE_A;
			sm_GENE_SIM_MF_RWResnik.ID_GENE_B = sr.ID_GENE_B;
			sm_GENE_SIM_MF_RWResnik.sim = sr.sim;
			sm.ID_GENE_A = gene_a;//assegno id primo gene nel nuovo record
			sm.ID_GENE_B = gene_b;//assegno id secondo gene nel nuovo record
			sm.sim = max_sim;//assegno la massima similarit trovata al campo sim del record da aggiungere a GENE_SIM_SEMANTICA
			
			GENE_SIM_SEM_MF_RWRESNIK.add(sm);//aggiungo record a GENE_SIM_SEMANTICA.
			GENE_SIM_SEQ_MF_RWRESNIK.add(sm_GENE_SIM_MF_RWResnik);
			
		}
		
		int count = 0;
		double[] vettore_sim_sem_MF_RWRESNIK = new double[GENE_SIM_SEM_MF_RWRESNIK.size()];
		int count2 = 0;
		double[] vettore_sim_seq_MF_RWRESNIK = new double[GENE_SIM_SEQ_MF_RWRESNIK.size()];
		for(Sim_record sq:GENE_SIM_SEM_MF_RWRESNIK){
			vettore_sim_sem_MF_RWRESNIK[count] = sq.sim;
			count++;
		}
		for(Sim_record sc:GENE_SIM_SEQ_MF_RWRESNIK){
			vettore_sim_seq_MF_RWRESNIK[count2] = sc.sim;
			count2++;
		}
		
		int size = GENE_SIM_SEM_MF_RWRESNIK.size();
		
		StoreFile("correlazione/Sim_MF/GENE_SIM_SEM_MF_RWJIANG", GENE_SIM_SEM_MF_RWRESNIK);
		StoreFile("correlazione/Sim_MF/vettore_sim_sem_MF_RWJIANG", vettore_sim_sem_MF_RWRESNIK);
		StoreFile("correlazione/Sim_MF/GENE_SIM_SEQ_MF_RWJIANG", GENE_SIM_SEQ_MF_RWRESNIK);
		StoreFile("correlazione/Sim_MF/vettore_sim_seq_MF_RWJIANG", vettore_sim_seq_MF_RWRESNIK);
		StoreFile("correlazione/Sim_MF/sim_size_MF_RWJIANG",size);

	}
	
	
	
	public static void StoreFile(String FileName, Object structure){
		System.out.println("Storing "+FileName+"...");
		ObjectOutputStream oss;
        try{
            oss = new ObjectOutputStream(new FileOutputStream(FileName));
            oss.writeObject(structure);
            oss.close();
        }
        catch(Exception e1){
                System.out.println("error during store "+FileName);
                e1.printStackTrace();
        }
        System.out.println("Done!");
	}

}