package obo;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.Hashtable;

import sim_calc.FileIn;
import sim_calc.GO;
import sim_calc.Gene;
import sim_calc.Gene_res;
import annotation.GeneAnnotation_parser;
import annotation.ParsingAnnotatioFile;

public class ThreadCalcolaGene extends Thread{
	
	Misura mi;
	String Path;
	ArrayList<String> evidence;
	ArrayList<String> lista_geni;
	
	public ThreadCalcolaGene (Misura mi,String Path,ArrayList<String> evidence,ArrayList<String> lista_geni){
		this.mi = mi;
		this.Path = Path;
		this.evidence = evidence;
		this.lista_geni = lista_geni;
	}
	
	public void run(){
			System.out.println("Thread Gene, evidence da ignorare:");
			for(String evi:evidence){
				System.out.println(evi);
			}
	
			boolean fatto=false;
			ArrayList<FileIn> lista_file = new ArrayList<FileIn>();
			ObjectInputStream ois_file;
			System.out.println("carico lista file...");
			try{
				ois_file = new ObjectInputStream(new FileInputStream(Path+"sim_calc/lista_file"));
				lista_file = (ArrayList<FileIn>)ois_file.readObject();
			}
			catch(Exception e_f){
				System.out.println("errore caricamento lista_file");
			}
			System.out.println("fatto!");
			
			String dom_utente;
			if(mi.Aspect.startsWith("b"))dom_utente="BP";
			else if(mi.Aspect.startsWith("c"))dom_utente="CC";
			else dom_utente="MF";
			
			//determino termini associati ai geni indicati - servir per trovare tutti i termini annotati con i geni indicati dall'utente//
		    String fil;
		    if(mi.organism.compareTo("Saccharomyce")==0)fil="gene_association.sgd";
		    else if(mi.organism.compareTo("Arabidopsis")==0)fil="gene_association.tair";
		    else if(mi.organism.compareTo("Fly")==0)fil="gene_association.fb";
		    else if(mi.organism.compareTo("Elegans")==0)fil="gene_association.wb";
		    else fil="gene_association.mgi";
		    
		    String annotationFilename = Path+"sim_calc/annotazioni/"+fil;
		    GeneAnnotation_parser gp = new GeneAnnotation_parser(annotationFilename, evidence, lista_geni);
		    gp.build_table();
		    //----------------------------//
			
			for(FileIn fi : lista_file){//scorro lista file nel sistema
				System.out.println("file analizzato:");
				System.out.println("versione = "+fi.versione_OBO);
				System.out.println("organismo = "+fi.organismo);
				System.out.println("dimensione hash dom_evidence = "+fi.dom_evidence.size());
				for(String dx : fi.dom_evidence.keySet()){
					System.out.println("dominio = "+dx);
					System.out.println("evidence associale al dominio:");
					for(String ed: fi.dom_evidence.get(dx)){
						System.out.println("codice_ev = "+ed);
					}
				}
				ArrayList<Gene_res> results = new ArrayList<Gene_res>();
				for(String gen:lista_geni){//scorro lista geni
					for(String gen2:lista_geni){//per ciascun gene scorro lista geni
						boolean ce=false;
						Gene_res re = new Gene_res();
						re.id_gene_1 = gen;
						re.id_gene_2 = gen2;
						re.sim= new double[mi.measur.length];
						//se il file c':
						if( (fi.versione_OBO.compareTo(mi.versione)==0) && (fi.organismo.compareTo(mi.organism)==0) && (fi.dom_evidence.keySet().contains(dom_utente)) && (fi.dom_evidence.get(dom_utente).contains(mi.cod_dec_ev)) ){
							
							//carico hashtable id_termini
							Hashtable<String, Integer> mapping_ID_Indici= new Hashtable<String, Integer>();
						    ObjectInputStream ois;
						    System.out.println("start load mapping_ID_Indici...");
						    try{
						          ois = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/mapping_ID_Indici"));
						          mapping_ID_Indici = (Hashtable<String, Integer>) ois.readObject();
						      }
						      catch(Exception e){
						          System.out.println("error during loading mapping_ID_Indici");
						          e.printStackTrace();
						      }
						    System.out.println("done!");
						    //----------------------------//
						   
						    System.out.println("lunghezza measure: "+mi.measur.length);
						    int cou=mi.measur.length;
								for(int a=0;a<mi.measur.length;a++){
									if(mi.measur[a].compareTo("resnik")==0){
										double[][] RESNIK= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load RESNIK...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RESNIK"));
											RESNIK = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading RESNIK");
											e.printStackTrace();
										}
										System.out.println("done!");
										double sim=0.0;
										
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											System.out.println("il termine "+ter+"  annotato con il gene "+gen);
											if(!mapping_ID_Indici.contains(ter)){
												System.out.println("il termine non  in mapping indici termini della matrice della misura selezionata!");
												continue;
											}
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												System.out.println("il termine "+ter2+"  annotato con il gene "+gen2);
												if(!mapping_ID_Indici.contains(ter2)){
													System.out.println("il termine non  in mapping indici termini della matrice della misura selezionata!");
													continue;
												}
												if(RESNIK[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=RESNIK[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
									}
									else if(mi.measur[a].compareTo("lin")==0){//LIN
										double[][] LIN= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load LIN...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/LIN"));
											LIN = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading LIN");
											e.printStackTrace();
										}
										System.out.println("done!");
									
										double sim=0.0;
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												if(LIN[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=LIN[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
									}
									
									else if(mi.measur[a].compareTo("jiang")==0){//JIANG
										double[][] JIANG= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load JIANG...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/JIANG"));
											JIANG = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading JIANG");
											e.printStackTrace();
										}
										System.out.println("done!");
									
										double sim=0.0;
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												if(JIANG[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=JIANG[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
									}
									
									else if(mi.measur[a].compareTo("resnik_with_downward_random_walk")==0){//RW+RESNIK
										
										double[][] RWRESNIK= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load RWresnik...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWRESNIK"));
											RWRESNIK = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading RWRESNIK");
											e.printStackTrace();
										}
										System.out.println("done!");
									
										double sim=0.0;
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												if(RWRESNIK[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=RWRESNIK[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
									}
									
									else if(mi.measur[a].compareTo("lin_with_downward_random_walk")==0){//RW+LIN
										double[][] RWLIN= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load RWLIN...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWLIN"));
											RWLIN = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading RWLIN");
											e.printStackTrace();
										}
										System.out.println("done!");
									
										double sim=0.0;
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												if(RWLIN[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=RWLIN[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
									}
									
									else if(mi.measur[a].compareTo("jiang_with_downward_random_walk")==0){//RW+JIANG
										double[][] RWJIANG= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load RWJIANG...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWJIANG"));
											RWJIANG = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading RWJIANG");
											e.printStackTrace();
										}
										System.out.println("done!");
									
										double sim=0.0;
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												if(RWJIANG[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=RWJIANG[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
										
									}//chiude misura
									
								}//chiude for che scorre misure
								results.add(re);
								
						}//chiude if file c'
						else{
							//se il file non c'
							String path_to_anno_file;
							if(mi.organism.compareTo("Saccharomyce")==0)path_to_anno_file = "./workspace/sim_calc/gene_association.sgd";
							else if(mi.organism.compareTo("Arabidopsis")==0)path_to_anno_file = "./workspace/sim_calc/annotazioni/gene_association.tair";
							else if(mi.organism.compareTo("Elegans")==0)path_to_anno_file = "./workspace/sim_calc/annotazioni/gene_association.wb";
							else if(mi.organism.compareTo("Fly")==0)path_to_anno_file = "./workspace/sim_calc/annotazioni/gene_association.fb";
							else path_to_anno_file = "./workspace/sim_calc/annotazioni/gene_association.mgi";
							
							String Aspect_for_parsing;
							if(mi.Aspect.startsWith("b"))Aspect_for_parsing="P";
							else if(mi.Aspect.startsWith("c")) Aspect_for_parsing="C";
							else Aspect_for_parsing="F";
							
							ParsingAnnotatioFile paf = new ParsingAnnotatioFile();
							paf.storeAnnotations(mi.cod_dec_ev, mi.versione, mi.organism, path_to_anno_file, Aspect_for_parsing, mi.ev_def);
							
							String path_new_file = "./workspace/sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev;
							String path_version = "./workspace/sim_calc/"+mi.versione;
							Get_TREE_P cl = new Get_TREE_P();
							try {
								cl.get_tree_p(path_version,path_new_file, Aspect_for_parsing);
							} catch (FileNotFoundException e) {
								System.out.println("errore, path verso nuovi file non trovato!");
								e.printStackTrace();
							}
							
							Get_TREE_LCA cl2 = new Get_TREE_LCA();
							cl2.get_tree_lca(path_version,path_new_file);
							
							Get_RESNIK cl3 = new Get_RESNIK();
							cl3.get_resnik(path_new_file);
							
							Get_LIN cl4 = new Get_LIN();
							cl4.get_lin(path_new_file);
							
							Get_JIANG cl5 = new Get_JIANG();
							cl5.get_jiang(path_new_file);
							
							String measure_host1 = "RESNIK";
							String measure_host2 = "LIN";
							String measure_host3 = "JIANG";
							
							Get_RandomWalk cl6 = new Get_RandomWalk();
							cl6.get_rw(path_version,path_new_file, Aspect_for_parsing, measure_host1);
							
							Get_RandomWalk cl7 = new Get_RandomWalk();
							cl7.get_rw(path_version,path_new_file, Aspect_for_parsing, measure_host2);
							
							Get_RandomWalk cl8 = new Get_RandomWalk();
							cl8.get_rw(path_version,path_new_file, Aspect_for_parsing, measure_host3);
							
							Hashtable<String, Integer> mapping_ID_Indici= new Hashtable<String, Integer>();
						    ObjectInputStream ois;
						    System.out.println("start load mapping_ID_Indici...");
						    try{
						          ois = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/mapping_ID_Indici"));
						          mapping_ID_Indici = (Hashtable<String, Integer>) ois.readObject();
						      }
						      catch(Exception e){
						          System.out.println("error during loading mapping_ID_Indici");
						          e.printStackTrace();
						      }
						    System.out.println("done!");
						    
						    System.out.println("lunghezza measure: "+mi.measur.length);
						    int cou=mi.measur.length;
								for(int a=0;a<mi.measur.length;a++){
									if(mi.measur[a].compareTo("resnik")==0){
										double[][] RESNIK= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load RESNIK...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RESNIK"));
											RESNIK = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading RESNIK");
											e.printStackTrace();
										}
										System.out.println("done!");
										double sim=0.0;
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												if(RESNIK[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=RESNIK[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
									}
									else if(mi.measur[a].compareTo("lin")==0){//LIN
										double[][] LIN= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load LIN...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/LIN"));
											LIN = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading LIN");
											e.printStackTrace();
										}
										System.out.println("done!");
									
										double sim=0.0;
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												if(LIN[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=LIN[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
									}
									
									else if(mi.measur[a].compareTo("jiang")==0){//JIANG
										double[][] JIANG= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load JIANG...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/JIANG"));
											JIANG = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading JIANG");
											e.printStackTrace();
										}
										System.out.println("done!");
									
										double sim=0.0;
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												if(JIANG[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=JIANG[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
									}
									
									else if(mi.measur[a].compareTo("resnik_with_downward_random_walk")==0){//RW+RESNIK
										
										double[][] RWRESNIK= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load RWresnik...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWRESNIK"));
											RWRESNIK = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading RWRESNIK");
											e.printStackTrace();
										}
										System.out.println("done!");
									
										double sim=0.0;
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												if(RWRESNIK[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=RWRESNIK[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
									}
									
									else if(mi.measur[a].compareTo("lin_with_downward_random_walk")==0){//RW+LIN
										double[][] RWLIN= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load RWLIN...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWLIN"));
											RWLIN = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading RWLIN");
											e.printStackTrace();
										}
										System.out.println("done!");
									
										double sim=0.0;
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												if(RWLIN[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=RWLIN[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
									}
									
									else if(mi.measur[a].compareTo("jiang_with_downward_random_walk")==0){//RW+JIANG
										double[][] RWJIANG= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
										ObjectInputStream ois1;
										System.out.println("start load RWJIANG...");
										try{
											ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWJIANG"));
											RWJIANG = (double[][]) ois1.readObject();
										}
										catch(Exception e){
											System.out.println("error during loading RWJIANG");
											e.printStackTrace();
										}
										System.out.println("done!");
									
										double sim=0.0;
										for(String ter:gp.Gene_termini.get(gen)){//scorro termini annotati con gene 1
											for(String ter2:gp.Gene_termini.get(gen2)){//scorro termini annotati con gene 2
												if(RWJIANG[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)]>sim)sim=RWJIANG[mapping_ID_Indici.get(ter)][mapping_ID_Indici.get(ter2)];
											}
										}
										re.sim[a]=sim;
										
									}//chiude misura
									
								}//chiude for che scorre misure
								results.add(re);
							
						}
						//-----------chiude se il file non c'-------------//
						
					}//chiude for che scorre geni interni
					
				}
				String result="";
				int ind=0;
				for(String mis:mi.measur){
					result=result+mis+"-";
					int cc_in=0;
					for(Gene_res r:results){//scorro risultati
							cc_in++;
							if(cc_in==results.size()){//ultimo
								result=result+r.sim[ind];
							}
							else{
								result=result+r.sim[ind]+"|";
							}
					}
					ind++;
					if(ind<mi.measur.length){//ultimo
						result=result+";";
					}
				}
				fatto=true;
				Gene.set_Risultati(result);
			}//chiude for che scorre tutti i file
			
			
	}
	public static double arrotondaPerEccesso(double valore, int cifreDecimali) {
	    double fattore = Math.pow(10, cifreDecimali);
	    return Math.ceil(valore * fattore) / fattore;
	}

}
