package annotation;

import java.io.*;
import java.net.*;
/* Class to download the annotation file from the GO website*/
public class DownloadAnnotFromURL {

	public static void main(String[] args) {
        try {
            URL url = new URL("http://cvsweb.geneontology.org/cgi-bin/cvsweb.cgi/go/gene-associations/gene_association.sgd.gz?rev=HEAD");
            
            System.out.println("Downloading ...");

            downloadFromUrl(url, "GZ_gene_annotation.sgd.gz");

            System.out.println("OK");
        } catch (Exception e) {
            System.err.println(e);
        }
    }


    public static void downloadFromUrl(URL url, String localFilename)
    throws IOException {
        InputStream is = null;
        FileOutputStream fos = null;

        try {
            URLConnection urlConn = url.openConnection();

            is = urlConn.getInputStream();
            fos = new FileOutputStream(localFilename);

            byte[] buffer = new byte[4096];
            int len;

            while ((len = is.read(buffer)) > 0) {
                fos.write(buffer, 0, len);
            }
        } finally {
            try {
                if (is != null) {
                    is.close();
                }
            } finally {
                if (fos != null) {
                    fos.close();
                }
            }
        }
    }//close main
}
