package annotation;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

public class SimParsing {
	
	/**  name of file that contains information about annotations of terms **/
    String SimFilename;    
    /** annotations table **/
    ArrayList<Sim_record> Annotations_Similarity;
    
    

	public SimParsing(String annotationFilename){
    	
    	this.SimFilename = annotationFilename;
    	this.Annotations_Similarity= new ArrayList<Sim_record>();
    	
    }
	public void build_table()
    {
    	try
        {
            FileReader fr = new FileReader(SimFilename);
            BufferedReader in = new BufferedReader(fr);
            String line;
            System.out.println("Start parsing...");
            while ((line = in.readLine()) != null){
            	//tralasciamo le righe che iniziano con !
            	if(line.startsWith("!")){continue;}
            	
            	/* per ogni linea(riga) letta dal file,
            	 * viene creato un oggetto di tipo 
            	 * Annotations_record(tupla),
            	 * quest'ultimo viene inserito nella
            	 * tabella delle annotazioni(Annotations_table)
            	 */
            	
            	Sim_record tupla = new Sim_record();
            	String[] output;
            	output =  line.split("\t");
            	tupla.ID_GENE_A=output[0];
            	//System.out.println("GENE_A = "+tupla.ID_GENE_A);
            	tupla.ID_GENE_B=output[1];
            	//System.out.println("GENE_B = "+tupla.ID_GENE_B);
            	tupla.sim=Double.parseDouble(output[5]);
            	//System.out.println("sim_A_B = "+tupla.sim);
            	
            	//aggiungo il record alla tabella Annotations_Similarity
            	Annotations_Similarity.add(tupla);
            	
            }
            
            System.out.println("END.");
        }
    	catch(IOException e){ }
    }

}
