package obo;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Hashtable;

import annotation.Annotation_parser_reduced;
import annotation.Annotations_record;
import annotation.Sim_record;

public class Confronto3 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		String Path = "C:/Users/jonh/workspace/";
		
		ArrayList<Sim_record> GENE_SIM = new ArrayList<Sim_record>();
		ObjectInputStream ois;
		System.out.println("start load GENE_SIM...");
		try{
			ois = new ObjectInputStream(new FileInputStream("C:/Users/jonh/workspace/sim_calc/GENE_SIM"));
		    GENE_SIM = (ArrayList<Sim_record>) ois.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading GENE_SIM");
			e.printStackTrace();
		}
		System.out.println("done!");
		System.out.println("GENE_SIM size = "+GENE_SIM.size());
		
		Hashtable<String, Integer> mapping_ID_Indici = new Hashtable<String, Integer>(); 
		ObjectInputStream ois1;
		System.out.println("start load mapping_ID_Indici...");
		try{
			ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/mapping_ID_Indici"));
			mapping_ID_Indici = (Hashtable<String, Integer>) ois1.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading mapping_ID_Indici");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		double[][] RWRESNIK= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
		ObjectInputStream ois2;
		System.out.println("start load RWresnik...");
		try{
			ois2 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/RWRESNIK"));
			RWRESNIK = (double[][]) ois2.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading RWRESNIK");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		String Aspect = "C";
		ArrayList<String>  Evidence_Code = new ArrayList<String>();//contiene gli evidence code da ignorare
		Evidence_Code.add("IEA");
		Evidence_Code.add("NR");
		Evidence_Code.add("ND");
		Evidence_Code.add("IC");
	    /* parsing del file delle annotazioni relativo ad uno specifico corpus (Saccharomyce)
	     * IL file non  quello di Paccanaro ma l'ultimo pubblicato da SGD in data 5/11/2011 */
	    Annotation_parser_reduced apr = new Annotation_parser_reduced("C:/Users/jonh/workspace/sim_calc/gene_association.sgd");
		apr.build_table_mod(Aspect, Evidence_Code);
		System.out.println("Anno_table_reduced size = "+apr.Annotation_Table.size());
		
		/* filtro i geni annotati con i termini del dominio CC */
		System.out.println("parsing annotation file, filtro annotazioni relative al dominio CC...");
		Hashtable <String, ArrayList<String>> geni_termini = new Hashtable<String, ArrayList<String>>();
		ArrayList<String> totale_termini = new ArrayList<String>();
		for(Annotations_record arr:apr.Annotation_Table){
			if(arr.c9_Aspect.compareTo("C")==0){//trovata tupla che associa un gene con un termine del dominio CC
				if(geni_termini.containsKey(arr.c3_DB_Object_Symbol)){
					if(geni_termini.get(arr.c3_DB_Object_Symbol).contains(arr.c5_GO_ID))continue;//il termine fa gi parte della lista dei termini annotati con quel gene
					//System.out.println("PRIMA geni-termini di "+arr.c3_DB_Object_Symbol+ "- dimensione = "+geni_termini.get(arr.c3_DB_Object_Symbol).size());
					geni_termini.get(arr.c3_DB_Object_Symbol).add(arr.c5_GO_ID);
					if(!totale_termini.contains(arr.c5_GO_ID))totale_termini.add(arr.c5_GO_ID);//se il termine non  presente nella lista totale dei termini GO appartenenti a CC annotati con un qualsiasi GENE appartenente al Saccharomyce, allora lo aggiungo. 
					//System.out.println("DOPO gene_termini di "+arr.c3_DB_Object_Symbol+" - dimensione = "+geni_termini.get(arr.c3_DB_Object_Symbol).size());
				}
				else{
					ArrayList<String> lista_termini_del_gene = new ArrayList<String>();
					lista_termini_del_gene.add(arr.c5_GO_ID);
					geni_termini.put(arr.c3_DB_Object_Symbol, lista_termini_del_gene);
					if(!totale_termini.contains(arr.c5_GO_ID))totale_termini.add(arr.c5_GO_ID);
				}
			}
		}
		System.out.println("fatto!");
		
		ArrayList<Sim_record> GENE_SIM_SEMANTICA = new ArrayList<Sim_record>();//conterr le similarit semantiche
		ArrayList<Sim_record> GENE_SIM_CC = new ArrayList<Sim_record>();
		for(Sim_record sr : GENE_SIM){//scorro coppie di geni nel file esterno
			String gene_a = sr.ID_GENE_A;//primo gene nella coppia
			System.out.println("GENE_A = "+gene_a);
			String gene_b = sr.ID_GENE_B;//secondo gene nella coppia
			System.out.println("GENE_B = "+gene_b);
			
			
			double max_sim=0.0;//conterr la similarit semantica tra i due geni che si stanno confrontando
			if(!geni_termini.containsKey(gene_a)){
				System.out.println("CC non contiene il gene_a = "+gene_a);
				continue;
			}
			for(String te: geni_termini.get(gene_a)){//prendo termini annotati con il primo gene
				int ind_te = mapping_ID_Indici.get(te);//prendo indice termine nella matrice di Resnik
				if(!geni_termini.containsKey(gene_b)){
					System.out.println("CC non contiene il gene_b = "+gene_b);
					continue;
				}
				for(String ot_te: geni_termini.get(gene_b)){//prendo termini secondo gene
					int ind_ot_te = mapping_ID_Indici.get(ot_te);//prendo indice termine nella matrice Resnik
					if(RWRESNIK[ind_te][ind_ot_te]>max_sim)max_sim=RWRESNIK[ind_te][ind_ot_te];//fra tutte le similarit prendo la massima
				}
			}
			Sim_record sm = new Sim_record();//creo il nuovo record che andr ad aggiungere a GENE_SIM_SEMANTICA
			Sim_record sm_GENE_SIM_CC = new Sim_record();
			sm_GENE_SIM_CC.ID_GENE_A = sr.ID_GENE_A;
			sm_GENE_SIM_CC.ID_GENE_B = sr.ID_GENE_B;
			sm_GENE_SIM_CC.sim = sr.sim;
			sm.ID_GENE_A = gene_a;//assegno id primo gene nel nuovo record
			sm.ID_GENE_B = gene_b;//assegno id secondo gene nel nuovo record
			sm.sim = max_sim;//assegno la massima similarit trovata al campo sim del record da aggiungere a GENE_SIM_SEMANTICA
			
			GENE_SIM_SEMANTICA.add(sm);//aggiungo record a GENE_SIM_SEMANTICA.
			GENE_SIM_CC.add(sm_GENE_SIM_CC);

	}
		int count = 0;
		double[] solo_sim_sem = new double[GENE_SIM_SEMANTICA.size()];
		int count2 = 0;
		double[] solo_sim = new double[GENE_SIM_CC.size()];
		for(Sim_record sq:GENE_SIM_SEMANTICA){
			solo_sim_sem[count] = sq.sim;
			count++;
		}
		for(Sim_record sc:GENE_SIM_CC){
			solo_sim[count2] = sc.sim;
			count2++;
		}
		
		int size = GENE_SIM_SEMANTICA.size();
		
		StoreFile("GENE_SIM_SEMANTICA_RWRESNIK", GENE_SIM_SEMANTICA);
		StoreFile("solo_sim_sem_RWRESNIK", solo_sim_sem);
		StoreFile("GENE_SIM_CC_RWRESNIK", GENE_SIM_CC);
		StoreFile("solo_sim_CC_RWRESNIK", solo_sim);
		StoreFile("sim_size_RWRESNIK",size);

	}
	
	public static void StoreFile(String FileName, Object structure){
		System.out.println("Storing "+FileName+"...");
		ObjectOutputStream oss;
        try{
            oss = new ObjectOutputStream(new FileOutputStream(FileName));
            oss.writeObject(structure);
            oss.close();
        }
        catch(Exception e1){
                System.out.println("error during store "+FileName);
                e1.printStackTrace();
        }
        System.out.println("Done!");
	}
}
