package obo;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

public class Get_RESNIK {
	
	public void get_resnik(String Path){
		System.out.println("Calcolo RESNIK...");
		/* costruisco matrice Resnik. La matrice di Resnik ha
	     * la stessa dimensione di TREE_LCA. Per ogni coppia di termini i-j viene calcolato:
	     * Resnik(i,j) = -log( TREE_LCA(i,j)/TREE_P_max )  */
		
		//carico terms_for_LCA
		ArrayList<String> terms_for_LCA = new ArrayList<String>();
		ObjectInputStream ois13;
		System.out.println("start load terms_for_LCA...");
		try{
			ois13 = new ObjectInputStream(new FileInputStream(Path+"/terms_for_LCA"));
		    terms_for_LCA = (ArrayList<String>) ois13.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading terms_for_LCA");
		    e.printStackTrace();
		}
		System.out.println("done!");
		
		//carico TREE_LCA
		double[][] TREE_LCA = new double[terms_for_LCA.size()][terms_for_LCA.size()];
	    ObjectInputStream ois15;
		  System.out.println("start load TREE_LCA...");
	    try{
	        ois15 = new ObjectInputStream(new FileInputStream(Path+"/TREE_LCA"));
	        TREE_LCA = (double[][]) ois15.readObject();
	        
	    }
	    catch(Exception e){
	        System.out.println("error during loading TREE_LCA");
	        e.printStackTrace();
	    }
	    System.out.println("done!");
	    
	  //carico TREE_P_max
	  double TREE_P_max=0.0;
	  ObjectInputStream ois16;
	  System.out.println("start load TREE_P_max...");
	  try{
		  ois16 = new ObjectInputStream(new FileInputStream(Path+"/TREE_P_max"));
	  	  TREE_P_max = (Double) ois16.readObject();
	  }
	  catch(Exception e){
		  System.out.println("error during loading TREE_P_max");
	  	  e.printStackTrace();
	  }
	  System.out.println("done!");
	    
	  double[][] RESNIK = new double[TREE_LCA.length][TREE_LCA[0].length];
	  for(int fg=0;fg<RESNIK.length;fg++){//scorro righe
	       for(int mi=0;mi<RESNIK[0].length;mi++){//scorro colonne
	    	   RESNIK[fg][mi] = -Math.log((TREE_LCA[fg][mi]/TREE_P_max));
	       }
	    } 
	  System.out.println("RESNIK[0][0] "+RESNIK[0][0]);
	  System.out.println("RESNIK[0][1] "+RESNIK[0][1]);
	  System.out.println("RESNIK[1][0] "+RESNIK[1][0]);
	  System.out.println("RESNIK[1][1] "+RESNIK[1][1]);
	    
	    StoreFile(Path+"/RESNIK",RESNIK);
	    System.out.println("Fine calcolo RESNIK!");
	}
	
	
	
	public static void StoreFile(String FileName, Object structure){
	System.out.println("Storing "+FileName+"...");
		ObjectOutputStream oss;
        try{
            oss = new ObjectOutputStream(new FileOutputStream(FileName));
            oss.writeObject(structure);
            oss.close();
        }
        catch(Exception e1){
                System.out.println("error during store "+FileName);
                e1.printStackTrace();
        }
        System.out.println("Done!");
	}

	
}
