package obo;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Hashtable;

import sim_calc.Tupla_gene;
import annotation.Annotation_parser_reduced;
import annotation.Annotations_record;

public class Pacca_BP_rw_lin {

	public static void main(String[] args) {
		System.out.println("Start Pacca_BP_RWlin...");
		Hashtable<String, Double> finale = new Hashtable<String, Double>();
		ObjectInputStream ois;
		System.out.println("start load finale...");
		try{
			ois = new ObjectInputStream(new FileInputStream("finale"));
			finale= (Hashtable<String, Double>) ois.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading finale");
			e.printStackTrace();
		}
		System.out.println("done!");
		System.out.println("finale size = "+finale.size());
		
		
		/* carico file go_ontology corrispondente all'ontologia parsata */
		OBOReader go_ontology = null;
		ObjectInputStream ois7;
		System.out.println("start load go_ontology...");
		try{
			ois7 = new ObjectInputStream(new FileInputStream("release_01-01-2011/go_ontology"));
		    go_ontology = (OBOReader) ois7.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading go_ontology");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		/* carico ontologia relativa al dominio TreeBP */
		ArrayList<Tupla_Tabella_GO>TreeBP = new ArrayList<Tupla_Tabella_GO>();
	    ObjectInputStream ois2;
	    System.out.println("start load TreeBP...");
	    try{
	          ois2 = new ObjectInputStream(new FileInputStream("release_01-01-2011/TreeBP"));
	          TreeBP = (ArrayList<Tupla_Tabella_GO>) ois2.readObject();
	      }
	      catch(Exception e){
	          System.out.println("error during loading TreeBP");
	          e.printStackTrace();
	      }
	    System.out.println("done!");
	    
	    Hashtable<String, ArrayList<String>>UpBP = new Hashtable<String, ArrayList<String>>();
	    ObjectInputStream ois5;
	    System.out.println("start load UpBP...");
	    try{
	          ois5 = new ObjectInputStream(new FileInputStream("release_01-01-2011/UpBP"));
	          UpBP = (Hashtable<String, ArrayList<String>>) ois5.readObject();
	          
	      }
	      catch(Exception e){
	          System.out.println("error during loading UpBP");
	          e.printStackTrace();
	      }
	    System.out.println("done!");
	    
	    Hashtable<String, ArrayList<String>>DownBP = new Hashtable<String, ArrayList<String>>();
	    ObjectInputStream ois6;
	    System.out.println("start load DownBP...");
	    try{
	          ois6 = new ObjectInputStream(new FileInputStream("release_01-01-2011/DownBP"));
	          DownBP = (Hashtable<String, ArrayList<String>>) ois6.readObject();
	          
	      }
	      catch(Exception e){
	          System.out.println("error during loading DownBP");
	          e.printStackTrace();
	      }
	    System.out.println("done!");
	    
	    String Aspect = "P";
		ArrayList<String>  Evidence_Code = new ArrayList<String>();//contiene gli evidence code da ignorare
		Evidence_Code.add("IEA");
		Evidence_Code.add("NR");
		Evidence_Code.add("ND");
		Evidence_Code.add("IC");
	    /* parsing del file delle annotazioni relativo ad uno specifico corpus (Saccharomyce)
	     * IL file non  quello di Paccanaro ma l'ultimo pubblicato da SGD in data 5/11/2011 */
	    Annotation_parser_reduced apr = new Annotation_parser_reduced("gene_association.sgd");
		apr.build_table_mod(Aspect, Evidence_Code);
		System.out.println("Anno_table_reduced size = "+apr.Annotation_Table.size());
		
		/* filtro i geni annotati con i termini del dominio BP */
		System.out.println("parsing annotation file, filtro annotazioni relative al dominio BP...");
		Hashtable <String, ArrayList<String>> geni_termini = new Hashtable<String, ArrayList<String>>();
		ArrayList<String> totale_termini = new ArrayList<String>();
		for(Annotations_record arr:apr.Annotation_Table){
			
				if(geni_termini.containsKey(arr.c3_DB_Object_Symbol)){
					if(geni_termini.get(arr.c3_DB_Object_Symbol).contains(arr.c5_GO_ID))continue;//il termine fa gi parte della lista dei termini annotati con quel gene
					geni_termini.get(arr.c3_DB_Object_Symbol).add(arr.c5_GO_ID);
					if(!totale_termini.contains(arr.c5_GO_ID))totale_termini.add(arr.c5_GO_ID);//se il termine non  presente nella lista totale dei termini GO appartenenti a BP annotati con un qualsiasi GENE appartenente al Saccharomyce, allora lo aggiungo. 
					
				}
				else{
					ArrayList<String> lista_termini_del_gene = new ArrayList<String>();
					lista_termini_del_gene.add(arr.c5_GO_ID);
					geni_termini.put(arr.c3_DB_Object_Symbol, lista_termini_del_gene);
					if(!totale_termini.contains(arr.c5_GO_ID))totale_termini.add(arr.c5_GO_ID);
				}
			
		}
		System.out.println("fatto!");
		
		System.out.println("numero geni = "+geni_termini.size());
		
		//carico mapping_ID_Indici_BP
		Hashtable<String, Integer>mapping_ID_Indici = new Hashtable<String, Integer>();
	    ObjectInputStream ois8;
	    System.out.println("start load MATRCICI_BP/mapping_ID_Indici...");
	    try{
	          ois8 = new ObjectInputStream(new FileInputStream("release_01-01-2011/Saccharomyce/GAF_2011-01-01/BP/15-0/mapping_ID_Indici"));
	          mapping_ID_Indici = (Hashtable<String, Integer>) ois8.readObject();
	          
	      }
	      catch(Exception e){
	          System.out.println("error during loading MATRICI_BP/mapping_ID_Indici");
	          e.printStackTrace();
	      }
	    System.out.println("done!");
		
	    System.out.println("Carico RWLIN...");
	    double[][] RWLIN = new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
	    ObjectInputStream ois9;
	    System.out.println("start load MATRICI_BP/RWLIN...");
	    try{
	          ois9 = new ObjectInputStream(new FileInputStream("release_01-01-2011/Saccharomyce/GAF_2011-01-01/BP/15-0/RWLIN"));
	          RWLIN = (double[][]) ois9.readObject();
	          
	      }
	      catch(Exception e){
	          System.out.println("error during loading MATRICI_BP/RWLIN");
	          e.printStackTrace();
	      }
	    System.out.println("done!");
	    //------------FINE CALCOLO RESNIK---------------------//
		
		/* per ogni record di GENE_SIM calcolo la corrispettiva similarit semantica */
		
		ArrayList<Tupla_gene> GENE_SIM_SEM_BP_RWLIN = new ArrayList<Tupla_gene>();//conterr le similarit semantiche
		ArrayList<Tupla_gene> GENE_SIM_SEQ_BP_RWLIN = new ArrayList<Tupla_gene>();
		for(String sr : finale.keySet()){//scorro coppie di geni nel file esterno
			String[] sp = sr.split(";");
			String gene_a = sp[0];//primo gene nella coppia
			String gene_b = sp[1];//secondo gene nella coppia
			
			double max_sim=0.0;//conterr la similarit semantica tra i due geni che si stanno confrontando
			if(!geni_termini.containsKey(gene_a)){
				continue;//il gene_a non  annotato con termini del dominio considerato
			}
			if(!geni_termini.containsKey(gene_b)){
				continue;//il gene_b non  annotato con termini del dominio considerato
			}
			for(String te: geni_termini.get(gene_a)){//prendo termini annotati con il primo gene
				int ind_te = mapping_ID_Indici.get(te);//prendo indice termine nella matrice di Resnik
				
				for(String ot_te: geni_termini.get(gene_b)){//prendo termini secondo gene
					int ind_ot_te = mapping_ID_Indici.get(ot_te);//prendo indice termine nella matrice Resnik
					if(RWLIN[ind_te][ind_ot_te]>max_sim)max_sim=RWLIN[ind_te][ind_ot_te];//fra tutte le similarit prendo la massima
				}
			}
			//similarit di sequenza
			Tupla_gene sm_GENE_SIM_BP_RWLIN = new Tupla_gene();//RECORD CHE AGGIUNGER GENE_SIM_SEQ
			sm_GENE_SIM_BP_RWLIN.id_1 = sp[0];
			sm_GENE_SIM_BP_RWLIN.id_2 = sp[1];
			sm_GENE_SIM_BP_RWLIN.sim = finale.get(sr);
			//similarit semantica
			Tupla_gene sm = new Tupla_gene();//creo il nuovo record che andr ad aggiungere a GENE_SIM_SEM
			sm.id_1 = gene_a;//assegno id primo gene nel nuovo record
			sm.id_2 = gene_b;//assegno id secondo gene nel nuovo record
			sm.sim = max_sim;//assegno la massima similarit trovata al campo sim del record da aggiungere a GENE_SIM_SEMANTICA
			
			GENE_SIM_SEM_BP_RWLIN.add(sm);//aggiungo record a GENE_SIM_SEMANTICA.
			GENE_SIM_SEQ_BP_RWLIN.add(sm_GENE_SIM_BP_RWLIN);//aggiungo record a GENE SIM_Sequenza
			
		}
		//calcolo i vettori delle due similarit(semantica e sequenza)
		int count = 0;
		double[] vettore_PACCA_sim_sem_BP_RWLIN = new double[GENE_SIM_SEM_BP_RWLIN.size()];
		int count2 = 0;
		double[] vettore_PACCA_sim_seq_BP_RWLIN = new double[GENE_SIM_SEQ_BP_RWLIN.size()];
		for(Tupla_gene sq:GENE_SIM_SEM_BP_RWLIN){
			vettore_PACCA_sim_sem_BP_RWLIN[count] = sq.sim;
			count++;
		}
		for(Tupla_gene sc:GENE_SIM_SEQ_BP_RWLIN){
			vettore_PACCA_sim_seq_BP_RWLIN[count2] = sc.sim;
			count2++;
		}
		
		int size = GENE_SIM_SEM_BP_RWLIN.size();
		
		StoreFile("corr2/Sim_BP/GENE_SIM_SEM_BP_RWLIN", GENE_SIM_SEM_BP_RWLIN);
		StoreFile("corr2/Sim_BP/vettore_PACCA_sim_sem_BP_RWLIN", vettore_PACCA_sim_sem_BP_RWLIN);
		StoreFile("corr2/Sim_BP/GENE_SIM_SEQ_BP_RWLIN", GENE_SIM_SEQ_BP_RWLIN);
		StoreFile("corr2/Sim_BP/vettore_PACCA_sim_seq_BP_RWLIN", vettore_PACCA_sim_seq_BP_RWLIN);
		StoreFile("corr2/Sim_BP/sim_size_BP_RWLIN",size);

	}
	
	
	
	public static void StoreFile(String FileName, Object structure){
		System.out.println("Storing "+FileName+"...");
		ObjectOutputStream oss;
        try{
            oss = new ObjectOutputStream(new FileOutputStream(FileName));
            oss.writeObject(structure);
            oss.close();
        }
        catch(Exception e1){
                System.out.println("error during store "+FileName);
                e1.printStackTrace();
        }
        System.out.println("Done!");
	}

}
