package obo;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.Hashtable;

import sim_calc.FileIn;
import sim_calc.GO;
import annotation.ParsingAnnotatioFile;

public class ThreadCalcola extends Thread{
	
	Misura mi;
	String Path;
	
	public ThreadCalcola (Misura mi,String Path){
		this.mi = mi;
		this.Path = Path;
	}
	
	public void run(){
			boolean fatto=false;
			ArrayList<FileIn> lista_file = new ArrayList<FileIn>();
			ObjectInputStream ois_file;
			System.out.println("carico lista file...");
			try{
				ois_file = new ObjectInputStream(new FileInputStream(Path+"sim_calc/lista_file"));
				lista_file = (ArrayList<FileIn>)ois_file.readObject();
			}
			catch(Exception e_f){
				System.out.println("errore caricamento lista_file");
			}
			System.out.println("fatto!");
			
			String dom_utente;
			if(mi.Aspect.startsWith("b"))dom_utente="BP";
			else if(mi.Aspect.startsWith("c"))dom_utente="CC";
			else dom_utente="MF";
			
			for(FileIn fi : lista_file){//scorro lista file nel sistema
				System.out.println("file analizzato:");
				System.out.println("versione = "+fi.versione_OBO);
				System.out.println("organismo = "+fi.organismo);
				System.out.println("dimensione hash dom_evidence = "+fi.dom_evidence.size());
				for(String dx : fi.dom_evidence.keySet()){
					System.out.println("dominio = "+dx);
					System.out.println("evidence associale al dominio:");
					for(String ed: fi.dom_evidence.get(dx))System.out.println("codice_ev = "+ed);
				}
				//se il file c'�:
				if( (fi.versione_OBO.compareTo(mi.versione)==0) && (fi.organismo.compareTo(mi.organism)==0) && (fi.dom_evidence.keySet().contains(dom_utente)) && (fi.dom_evidence.get(dom_utente).contains(mi.cod_dec_ev)) ){
					
					Hashtable<String, Integer> mapping_ID_Indici= new Hashtable<String, Integer>();
				    ObjectInputStream ois;
				    System.out.println("start load mapping_ID_Indici...");
				    try{
				          ois = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/mapping_ID_Indici"));
				          mapping_ID_Indici = (Hashtable<String, Integer>) ois.readObject();
				      }
				      catch(Exception e){
				          System.out.println("error during loading mapping_ID_Indici");
				          e.printStackTrace();
				      }
				    System.out.println("done!");
				    
				  //determino la lista totale dei termini(lista+centrato+annotazioni)
					 ArrayList<String> tutti_i_termini = new ArrayList<String>();
					   
					    if(mi.termini.compareTo("NO")!=0){//se ci sono termini da LISTA
					    	System.out.println("entro LISTA");
					    	for(int d=0;d<mi.terms.length;d++){
					    		tutti_i_termini.add(mi.terms[d]);
					    	}
					    }
					    
					    if(mi.term.compareTo("NO")!=0){//se ci sono termini CENTRATO
					    	System.out.println("entro CENTRATO");
					    	OBOReader onto = null;
					    	ObjectInputStream ois_o;
						    System.out.println("start load go_ontology...");
						    try{
						          ois_o = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/go_ontology"));
						          onto = (OBOReader) ois_o.readObject();
						      }
						      catch(Exception e){
						          System.out.println("error during loading go_ontology");
						          e.printStackTrace();
						      }
						    System.out.println("done!");
						    
						    
						    if(!tutti_i_termini.contains(mi.termine_centrato))tutti_i_termini.add(mi.termine_centrato);
						    //System.out.println("tutti = "+tutti_i_termini);
						    TermInfo ter = onto.getTerm(mi.termine_centrato);
						    if(mi.discendenti){
						    	String disce = new String();
						    	disce = onto.getList(ter, disce);
						    	//System.out.println("discend = "+disce);
							    String temp1[];
							    temp1 = disce.split("\n");
							    //System.out.println("numero disce = "+temp1.length);
							    for(String az : temp1){
							    	//System.out.println("entro disce");
							    	//System.out.println("t_disce = "+az);
							    	if(!tutti_i_termini.contains(az)){
							    		if(!mapping_ID_Indici.keySet().contains(az)){
											System.out.println("termine: "+az+" NON ha annotazioni, quindi non viene considerato nella matrice finale delle misure di sim ");
										}
							    		else tutti_i_termini.add(az);
							    	}
							    }
						    }
						    //System.out.println("tutti_dopo dicsce = "+tutti_i_termini);
						    if(mi.antenati){
						    	String ante = new String();
						    	ante = onto.getAncestorList(ter, ante);
							    String temp2[] = ante.split("\n");
							    //System.out.println("numero ante = "+temp2.length);
							    for(String bz: temp2){
							    	//System.out.println("t_ante = "+temp2[b]);
							    	//System.out.println("entro ante");
							    	if(!tutti_i_termini.contains(bz)){
							    		if(!mapping_ID_Indici.keySet().contains(bz)){
											System.out.println("termine: "+bz+" NON ha annotazioni, quindi non viene considerato nella matrice finale delle misure di sim ");
										}
							    		else tutti_i_termini.add(bz);
							    	}
							    }
						    } 
						    //System.out.println("tutti_ dopo ante = "+tutti_i_termini);
					    }
					    
					    if(mi.anno_da!=-1){//se ci sono NUMERO ANNOTAZIONI
					    	
					    	Hashtable<String, Double> GO_GENE_NoBranch= new Hashtable<String, Double>();
						    ObjectInputStream ois_an;
						    System.out.println("start load GO_GENE_NoBranch...");
						    try{
						          ois_an = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/mapping_ID_Indici"));
						          GO_GENE_NoBranch = (Hashtable<String, Double>) ois_an.readObject();
						      }
						      catch(Exception e){
						          System.out.println("error during loading GO_GENE_NoBranch");
						          e.printStackTrace();
						      }
						    System.out.println("done!");
						    
						    for(String tr: GO_GENE_NoBranch.keySet()){
						    	//System.out.println("GO_GENE_NoBranch size = "+GO_GENE_NoBranch.size());
						    	//System.out.println("termine = "+GO_GENE_NoBranch.get(tr));
						    	
						    	if( (Double.parseDouble(""+GO_GENE_NoBranch.get(tr)+"") >= mi.anno_da) && (Double.parseDouble(""+GO_GENE_NoBranch.get(tr)+"") <= mi.anno_a)){
						    		if(!tutti_i_termini.contains(tr))tutti_i_termini.add(tr);
						    	}
						    }
					    	
					    }
				    
					
					    
				    String result="";
				    int count_t = 0;
				    System.out.println("dimensione tutti = "+tutti_i_termini);
				    for(String ty: tutti_i_termini){
				    	count_t++;
				    	if(count_t<tutti_i_termini.size())result=result+ty+"-";
				    	else if(count_t==tutti_i_termini.size())result=result+ty+"/";
				    	
				    }
				    System.out.println("lunghezza measure: "+mi.measur.length);
				    int cou=0;
						for(int a=0;a<mi.measur.length;a++){
							cou++;
							
							if(mi.measur[a].compareTo("resnik")==0){
								result = result+mi.measur[a];
								double[][] RESNIK= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
								ObjectInputStream ois1;
								System.out.println("start load RESNIK...");
								try{
									ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RESNIK"));
									RESNIK = (double[][]) ois1.readObject();
								}
								catch(Exception e){
									System.out.println("error during loading RESNIK");
									e.printStackTrace();
								}
								System.out.println("done!");
							
								for(String tm: tutti_i_termini){
									if(!mapping_ID_Indici.keySet().contains(tm))continue;
									int ind_t = mapping_ID_Indici.get(tm);
									for(String tmc : tutti_i_termini){
										if(!mapping_ID_Indici.keySet().contains(tmc))continue;
										int ind_t2 = mapping_ID_Indici.get(tmc);
										result=result+"|"+arrotondaPerEccesso(RESNIK[ind_t][ind_t2], 2);
									}
								}
								result=result+";";
							}
							else if(mi.measur[a].compareTo("lin")==0){//LIN
								result = result+mi.measur[a];
								double[][] LIN= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
								ObjectInputStream ois1;
								System.out.println("start load LIN...");
								try{
									ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/LIN"));
									LIN = (double[][]) ois1.readObject();
								}
								catch(Exception e){
									System.out.println("error during loading LIN");
									e.printStackTrace();
								}
								System.out.println("done!");
							
								for(String tm: tutti_i_termini){
									if(!mapping_ID_Indici.keySet().contains(tm))continue;
									int ind_t = mapping_ID_Indici.get(tm);
									for(String tmc : tutti_i_termini){
										if(!mapping_ID_Indici.keySet().contains(tmc))continue;
										int ind_t2 = mapping_ID_Indici.get(tmc);
										result=result+"|"+arrotondaPerEccesso(LIN[ind_t][ind_t2], 2);
									}
								}
								result=result+";";
							}
							
							else if(mi.measur[a].compareTo("jiang")==0){//JIANG
								result = result+mi.measur[a];
								double[][] JIANG= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
								ObjectInputStream ois1;
								System.out.println("start load JIANG...");
								try{
									ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/JIANG"));
									JIANG = (double[][]) ois1.readObject();
								}
								catch(Exception e){
									System.out.println("error during loading JIANG");
									e.printStackTrace();
								}
								System.out.println("done!");
							
								for(String tm: tutti_i_termini){
									if(!mapping_ID_Indici.keySet().contains(tm))continue;
									int ind_t = mapping_ID_Indici.get(tm);
									for(String tmc : tutti_i_termini){
										if(!mapping_ID_Indici.keySet().contains(tm))continue;
										int ind_t2 = mapping_ID_Indici.get(tmc);
										result=result+"|"+arrotondaPerEccesso(JIANG[ind_t][ind_t2], 2);
									}
								}
								result=result+";";
							}
							
							else if(mi.measur[a].compareTo("resnik_with_downward_random_walk")==0){//RW+RESNIK
								result = result+mi.measur[a];
								double[][] RWRESNIK= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
								ObjectInputStream ois1;
								System.out.println("start load RWresnik...");
								try{
									ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWRESNIK"));
									RWRESNIK = (double[][]) ois1.readObject();
								}
								catch(Exception e){
									System.out.println("error during loading RWRESNIK");
									e.printStackTrace();
								}
								System.out.println("done!");
							
								for(String tm: tutti_i_termini){
									if(!mapping_ID_Indici.keySet().contains(tm))continue;
									int ind_t = mapping_ID_Indici.get(tm);
									for(String tmc : tutti_i_termini){
										if(!mapping_ID_Indici.keySet().contains(tmc))continue;
										int ind_t2 = mapping_ID_Indici.get(tmc);
										result=result+"|"+arrotondaPerEccesso(RWRESNIK[ind_t][ind_t2], 2);
									}
								}
								result=result+";";
							}
							
							else if(mi.measur[a].compareTo("lin_with_downward_random_walk")==0){//RW+LIN
								result = result+mi.measur[a];
								double[][] RWLIN= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
								ObjectInputStream ois1;
								System.out.println("start load RWLIN...");
								try{
									ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWLIN"));
									RWLIN = (double[][]) ois1.readObject();
								}
								catch(Exception e){
									System.out.println("error during loading RWLIN");
									e.printStackTrace();
								}
								System.out.println("done!");
							
								for(String tm: tutti_i_termini){
									if(!mapping_ID_Indici.keySet().contains(tm))continue;
									int ind_t = mapping_ID_Indici.get(tm);
									for(String tmc : tutti_i_termini){
										if(!mapping_ID_Indici.keySet().contains(tmc))continue;
										int ind_t2 = mapping_ID_Indici.get(tmc);
										result=result+"|"+arrotondaPerEccesso(RWLIN[ind_t][ind_t2], 2);
									}
								}
								result=result+";";
							}
							
							else if(mi.measur[a].compareTo("jiang_with_downward_random_walk")==0){//RW+JIANG
								result = result+mi.measur[a];
								double[][] RWJIANG= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
								ObjectInputStream ois1;
								System.out.println("start load RWJIANG...");
								try{
									ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWJIANG"));
									RWJIANG = (double[][]) ois1.readObject();
								}
								catch(Exception e){
									System.out.println("error during loading RWJIANG");
									e.printStackTrace();
								}
								System.out.println("done!");
							
								for(String tm: tutti_i_termini){
									if(!mapping_ID_Indici.keySet().contains(tm))continue;
									int ind_t = mapping_ID_Indici.get(tm);
									for(String tmc : tutti_i_termini){
										if(!mapping_ID_Indici.keySet().contains(tmc))continue;
										int ind_t2 = mapping_ID_Indici.get(tmc);
										result=result+"|"+arrotondaPerEccesso(RWJIANG[ind_t][ind_t2], 2);
									}
								}
								result=result+";";
							}//chiude misura
						}//chiude for che scorre misure
						System.out.println("cou = "+cou);
						GO.set_Risultati(result);
						fatto=true;
						
				}//chiude if file c'�
			}//chiude for che scorre tutti i file
			
			if(!fatto){
			//se siamo qui, il file non esiste, quindi creiamo le strutture dati
		double[] perc_array = new double[7+mi.measur.length];		
		double startTime = System.currentTimeMillis();	
	System.out.println("*******************inizio" + startTime);	
			String path_to_anno_file;
			if(mi.organism.compareTo("Saccharomyce")==0)path_to_anno_file = "./workspace/sim_calc/gene_association.sgd";
			else if(mi.organism.compareTo("Arabidopsis")==0)path_to_anno_file = "./workspace/sim_calc/annotazioni/gene_association.tair";
			else if(mi.organism.compareTo("Elegans")==0)path_to_anno_file = "./workspace/sim_calc/annotazioni/gene_association.wb";
			else if(mi.organism.compareTo("Fly")==0)path_to_anno_file = "./workspace/sim_calc/annotazioni/gene_association.fb";
			else path_to_anno_file = "./workspace/sim_calc/annotazioni/gene_association.mgi";
			
			String Aspect_for_parsing;
			if(mi.Aspect.startsWith("b"))Aspect_for_parsing="P";
			else if(mi.Aspect.startsWith("c")) Aspect_for_parsing="C";
			else Aspect_for_parsing="F";
			
			ParsingAnnotatioFile paf = new ParsingAnnotatioFile();
			paf.storeAnnotations(mi.cod_dec_ev, mi.versione, mi.organism, path_to_anno_file, Aspect_for_parsing, mi.ev_def);
			
			String path_new_file = "./workspace/sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev;
			String path_version = "./workspace/sim_calc/"+mi.versione;
			Get_TREE_P cl = new Get_TREE_P();
			try {
				cl.get_tree_p(path_version,path_new_file, Aspect_for_parsing);
			} catch (FileNotFoundException e) {
				System.out.println("errore, path verso nuovi file non trovato!");
				e.printStackTrace();
			}
			double tmp = System.currentTimeMillis();
			System.out.println("prima tree_lca " + (tmp - startTime));	
			perc_array[0]= (tmp - startTime);
			Get_TREE_LCA cl2 = new Get_TREE_LCA();
			cl2.get_tree_lca(path_version,path_new_file);
			
			tmp = System.currentTimeMillis();
			System.out.println("prima Get_resnik " + (tmp - startTime));	
			perc_array[1]= (tmp - startTime);
			Get_RESNIK cl3 = new Get_RESNIK();
			cl3.get_resnik(path_new_file);
			
			tmp = System.currentTimeMillis();
			System.out.println("prima GET_lin " + (tmp - startTime));	
			perc_array[2]= (tmp - startTime);
			Get_LIN cl4 = new Get_LIN();
			cl4.get_lin(path_new_file);
			
			tmp = System.currentTimeMillis();
			System.out.println("prima GET_Jiang " + (tmp - startTime));	
			perc_array[3]= (tmp - startTime);
						
			Get_JIANG cl5 = new Get_JIANG();
			cl5.get_jiang(path_new_file);
			
			String measure_host1 = "RESNIK";
			String measure_host2 = "LIN";
			String measure_host3 = "JIANG";
			
			tmp = System.currentTimeMillis();
			System.out.println("prima getrw1 " + (tmp - startTime));	
			perc_array[4]= (tmp - startTime);
			Get_RandomWalk cl6 = new Get_RandomWalk();
			cl6.get_rw(path_version,path_new_file, Aspect_for_parsing, measure_host1);
			
			tmp = System.currentTimeMillis();
			System.out.println("prima getrw2 " + (tmp - startTime));	
			perc_array[5]= (tmp - startTime);
			Get_RandomWalk cl7 = new Get_RandomWalk();
			cl7.get_rw(path_version,path_new_file, Aspect_for_parsing, measure_host2);
			
			tmp = System.currentTimeMillis();
			System.out.println("prima getrw3 " + (tmp - startTime));	
			perc_array[6]= (tmp - startTime);
			Get_RandomWalk cl8 = new Get_RandomWalk();
			cl8.get_rw(path_version,path_new_file, Aspect_for_parsing, measure_host3);
			
			Hashtable<String, Integer> mapping_ID_Indici= new Hashtable<String, Integer>();
		    ObjectInputStream ois;
		    System.out.println("start load mapping_ID_Indici...");
		    try{
		          ois = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/mapping_ID_Indici"));
		          mapping_ID_Indici = (Hashtable<String, Integer>) ois.readObject();
		      }
		      catch(Exception e){
		          System.out.println("error during loading mapping_ID_Indici");
		          e.printStackTrace();
		      }
		    System.out.println("done!");
		    
		  //determino la lista totale dei termini(lista+centrato+annotazioni)
			 ArrayList<String> tutti_i_termini = new ArrayList<String>();
			   
			    if(mi.termini.compareTo("NO")!=0){//se ci sono termini da LISTA
			    	for(int d=0;d<mi.terms.length;d++){
			    		tutti_i_termini.add(mi.terms[d]);
			    	}
			    }
			    
			    if(mi.term.compareTo("NO")!=0){//se ci sono termini CENTRATO
			    	System.out.println("entro CENTRATO");
			    	OBOReader onto = null;
			    	ObjectInputStream ois_o;
				    System.out.println("start load go_ontology...");
				    try{
				          ois_o = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/go_ontology"));
				          onto = (OBOReader) ois_o.readObject();
				      }
				      catch(Exception e){
				          System.out.println("error during loading go_ontology");
				          e.printStackTrace();
				      }
				    System.out.println("done!");
				    
				    
				    if(!tutti_i_termini.contains(mi.termine_centrato))tutti_i_termini.add(mi.termine_centrato);
				    //System.out.println("tutti = "+tutti_i_termini);
				    TermInfo ter = onto.getTerm(mi.termine_centrato);
				    if(mi.discendenti){
				    	String disce = new String();
				    	disce = onto.getList(ter, disce);
				    	//System.out.println("discend = "+disce);
					    String temp1[];
					    temp1 = disce.split("\n");
					    //System.out.println("numero disce = "+temp1.length);
					    for(String az : temp1){
					    	//System.out.println("entro disce");
					    	//System.out.println("t_disce = "+az);
					    	if(!tutti_i_termini.contains(az)){
					    		if(!mapping_ID_Indici.keySet().contains(az)){
									System.out.println("termine: "+az+" NON ha annotazioni, quindi non viene considerato nella matrice finale delle misure di sim ");
								}
					    		else tutti_i_termini.add(az);
					    	}
					    }
				    }
				    //System.out.println("tutti_dopo dicsce = "+tutti_i_termini);
				    if(mi.antenati){
				    	String ante = new String();
				    	ante = onto.getAncestorList(ter, ante);
					    String temp2[] = ante.split("\n");
					    //System.out.println("numero ante = "+temp2.length);
					    for(String bz: temp2){
					    	//System.out.println("t_ante = "+temp2[b]);
					    	//System.out.println("entro ante");
					    	if(!tutti_i_termini.contains(bz)){
					    		if(!mapping_ID_Indici.keySet().contains(bz)){
									System.out.println("termine: "+bz+" NON ha annotazioni, quindi non viene considerato nella matrice finale delle misure di sim ");
								}
					    		else tutti_i_termini.add(bz);
					    	}
					    }
				    } 
				    //System.out.println("tutti_ dopo ante = "+tutti_i_termini);
			    }
			    
			    if(mi.anno_da!=-1){//se ci sono NUMERO ANNOTAZIONI
			    	
			    	Hashtable<String, Double> GO_GENE_NoBranch= new Hashtable<String, Double>();
				    ObjectInputStream ois_an;
				    System.out.println("start load GO_GENE_NoBranch...");
				    try{
				          ois_an = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/mapping_ID_Indici"));
				          GO_GENE_NoBranch = (Hashtable<String, Double>) ois_an.readObject();
				      }
				      catch(Exception e){
				          System.out.println("error during loading GO_GENE_NoBranch");
				          e.printStackTrace();
				      }
				    System.out.println("done!");
				    
				    for(String tr: GO_GENE_NoBranch.keySet()){
				    	//System.out.println("GO_GENE_NoBranch size = "+GO_GENE_NoBranch.size());
				    	//System.out.println("termine = "+GO_GENE_NoBranch.get(tr));
				    	if( (Double.parseDouble(""+GO_GENE_NoBranch.get(tr)+"") >= mi.anno_da) && (Double.parseDouble(""+GO_GENE_NoBranch.get(tr)+"") <= mi.anno_a)){
				    		if(!tutti_i_termini.contains(tr))tutti_i_termini.add(tr);
				    	}
				    }
			    	
			    }
		    
		    String result="";
		    int count_t = 0;
		    for(String ty: tutti_i_termini){
		    	count_t++;
		    	if(count_t<tutti_i_termini.size())result=result+ty+"-";
		    	else if(count_t==tutti_i_termini.size())result=result+ty+"/";
		    	
		    }
		   
		    
		    System.out.println("lunghezza measure: "+mi.measur.length);
		    int cou=0;
				for(int a=0;a<mi.measur.length;a++){
					cou++;
					tmp = System.currentTimeMillis();
					System.out.println("in lunghezza misure " + (tmp - startTime));	
					perc_array[7+a]= (tmp - startTime);
					if(mi.measur[a].compareTo("resnik")==0){
						result = result+mi.measur[a];
						double[][] RESNIK= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
						ObjectInputStream ois1;
						System.out.println("start load RESNIK...");
						try{
							ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RESNIK"));
							RESNIK = (double[][]) ois1.readObject();
						}
						catch(Exception e){
							System.out.println("error during loading RESNIK");
							e.printStackTrace();
						}
						System.out.println("done!");
					
						for(String tm: tutti_i_termini){
							if(!mapping_ID_Indici.keySet().contains(tm))continue;
							int ind_t = mapping_ID_Indici.get(tm);
							for(String tmc : tutti_i_termini){
								if(!mapping_ID_Indici.keySet().contains(tmc))continue;
								int ind_t2 = mapping_ID_Indici.get(tmc);
								result=result+"|"+arrotondaPerEccesso(RESNIK[ind_t][ind_t2], 2);
							}
						}
						result=result+";";
					}
					else if(mi.measur[a].compareTo("lin")==0){//LIN
						result = result+mi.measur[a];
						double[][] LIN= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
						ObjectInputStream ois1;
						System.out.println("start load LIN...");
						try{
							ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/LIN"));
							LIN = (double[][]) ois1.readObject();
						}
						catch(Exception e){
							System.out.println("error during loading LIN");
							e.printStackTrace();
						}
						System.out.println("done!");
					
						for(String tm: tutti_i_termini){
							if(!mapping_ID_Indici.keySet().contains(tm))continue;
							int ind_t = mapping_ID_Indici.get(tm);
							for(String tmc : tutti_i_termini){
								if(!mapping_ID_Indici.keySet().contains(tmc))continue;
								int ind_t2 = mapping_ID_Indici.get(tmc);
								result=result+"|"+arrotondaPerEccesso(LIN[ind_t][ind_t2], 2);
							}
						}
						result=result+";";
					}
					
					else if(mi.measur[a].compareTo("jiang")==0){//JIANG
						result = result+mi.measur[a];
						double[][] JIANG= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
						ObjectInputStream ois1;
						System.out.println("start load JIANG...");
						try{
							ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/JIANG"));
							JIANG = (double[][]) ois1.readObject();
						}
						catch(Exception e){
							System.out.println("error during loading JIANG");
							e.printStackTrace();
						}
						System.out.println("done!");
					
						for(String tm: tutti_i_termini){
							if(!mapping_ID_Indici.keySet().contains(tm))continue;
							int ind_t = mapping_ID_Indici.get(tm);
							for(String tmc : tutti_i_termini){
								if(!mapping_ID_Indici.keySet().contains(tmc))continue;
								int ind_t2 = mapping_ID_Indici.get(tmc);
								result=result+"|"+arrotondaPerEccesso(JIANG[ind_t][ind_t2], 2);
							}
						}
						result=result+";";
					}
					
					else if(mi.measur[a].compareTo("resnik_with_downward_random_walk")==0){//RW+RESNIK
						result = result+mi.measur[a];
						double[][] RWRESNIK= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
						ObjectInputStream ois1;
						System.out.println("start load RWresnik...");
						try{
							ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWRESNIK"));
							RWRESNIK = (double[][]) ois1.readObject();
						}
						catch(Exception e){
							System.out.println("error during loading RWRESNIK");
							e.printStackTrace();
						}
						System.out.println("done!");
					
						for(String tm: tutti_i_termini){
							if(!mapping_ID_Indici.keySet().contains(tm))continue;
							int ind_t = mapping_ID_Indici.get(tm);
							for(String tmc : tutti_i_termini){
								if(!mapping_ID_Indici.keySet().contains(tmc))continue;
								int ind_t2 = mapping_ID_Indici.get(tmc);
								result=result+"|"+arrotondaPerEccesso(RWRESNIK[ind_t][ind_t2], 2);
							}
						}
						result=result+";";
					}
					
					else if(mi.measur[a].compareTo("lin_with_downward_random_walk")==0){//RW+LIN
						result = result+mi.measur[a];
						double[][] RWLIN= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
						ObjectInputStream ois1;
						System.out.println("start load RWLIN...");
						try{
							ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWLIN"));
							RWLIN = (double[][]) ois1.readObject();
						}
						catch(Exception e){
							System.out.println("error during loading RWLIN");
							e.printStackTrace();
						}
						System.out.println("done!");
					
						for(String tm: tutti_i_termini){
							if(!mapping_ID_Indici.keySet().contains(tm))continue;
							int ind_t = mapping_ID_Indici.get(tm);
							for(String tmc : tutti_i_termini){
								if(!mapping_ID_Indici.keySet().contains(tmc))continue;
								int ind_t2 = mapping_ID_Indici.get(tmc);
								result=result+"|"+arrotondaPerEccesso(RWLIN[ind_t][ind_t2], 2);
							}
						}
						result=result+";";
					}
					
					else if(mi.measur[a].compareTo("jiang_with_downward_random_walk")==0){//RW+JIANG
						result = result+mi.measur[a];
						double[][] RWJIANG= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
						ObjectInputStream ois1;
						System.out.println("start load RWJIANG...");
						try{
							ois1 = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+mi.versione+"/"+mi.organism+"/GAF_2011-01-01/"+dom_utente+"/"+mi.cod_dec_ev+"/RWJIANG"));
							RWJIANG = (double[][]) ois1.readObject();
						}
						catch(Exception e){
							System.out.println("error during loading RWJIANG");
							e.printStackTrace();
						}
						System.out.println("done!");
					
						for(String tm: tutti_i_termini){
							if(!mapping_ID_Indici.keySet().contains(tm))continue;
							int ind_t = mapping_ID_Indici.get(tm);
							for(String tmc : tutti_i_termini){
								if(!mapping_ID_Indici.keySet().contains(tmc))continue;
								int ind_t2 = mapping_ID_Indici.get(tmc);
								result=result+"|"+arrotondaPerEccesso(RWJIANG[ind_t][ind_t2], 2);
							}
						}
						result=result+";";
					}//chiude misura
				}//chiude for che scorre misure
				System.out.println("cou = "+cou);
				tmp = System.currentTimeMillis();
				System.out.println("fine " + (tmp - startTime));	
				perc_array[7+mi.measur.length]= (tmp - startTime);				
				for(int ii=0;ii<7+mi.measur.length;ii++)
				{
					perc_array[ii]= perc_array[ii]/perc_array[7+mi.measur.length-1];
				}
				GO.set_Risultati(result);
				
		}//chiude se NON fatto
	}
	public static double arrotondaPerEccesso(double valore, int cifreDecimali) {
	    double fattore = Math.pow(10, cifreDecimali);
	    return Math.ceil(valore * fattore) / fattore;
	}

}
