package sim_calc;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Hashtable;

import obo.OBOReader;
import obo.ParsingOBO;
import obo.TermInfo;
import obo.Tupla_Tabella_GO;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

@Path("/Checkterms")
public class Checkterms {
		@GET
		@Path("{version}/{branch}/{terms}/{termine}/{annot}")
		@Produces(MediaType.TEXT_PLAIN)
		public String post(
				@PathParam("version") String versione,
				@PathParam("branch") String Aspect,
				@PathParam("terms") String termini,
				@PathParam("termine") String term,
				@PathParam("annot") String num){
			String Path = "./workspace/";
			
			String[] campi_versione = versione.split("-");
			if(campi_versione[1].length()==1){
				campi_versione[1]="0"+campi_versione[1];
				versione = campi_versione[0]+"-"+campi_versione[1]+"-"+campi_versione[2];
			}
			
			
			System.out.println("versione = "+versione);
			System.out.println("branch = "+Aspect);
			String[] terms = termini.split("-");
			System.out.println("termini:");
			for(int ca=0;ca<terms.length;ca++){
				terms[ca]=terms[ca].replaceAll("_", ":");
				System.out.println(terms[ca]);
			}
			if(term.compareTo("NO")==0)System.out.println("NON concentrato sul termine");
			else{
				System.out.println("concentrato sul termine:");
				String[] t_a_d = term.split("-");
				for(int ca=0;ca<t_a_d.length;ca++){
					t_a_d[ca]=t_a_d[ca].replaceAll("_", ":");
					
				}
				
				String term_center = t_a_d[0];
				System.out.println(term_center);
				if(t_a_d.length==2)System.out.println(t_a_d[1]);
				if(t_a_d.length == 3){
					System.out.println(t_a_d[1]);
					System.out.println(t_a_d[2]);
				}
			}
			if(num.compareTo("NO")==0)System.out.println("NON numero di annotazioni");
			else{
				String[] a = num.split("-");
				System.out.println("Con numero di annotazioni comprese tra: "+a[0]+" e "+a[1]);
			}
			
			ArrayList<FileIn> lista_file = new ArrayList<FileIn>();
			ObjectInputStream ois_file;
			System.out.println("carico lista file...");
			try{
				ois_file = new ObjectInputStream(new FileInputStream(Path+"sim_calc/lista_file"));
				lista_file = (ArrayList<FileIn>)ois_file.readObject();
			}
			catch(Exception e_f){
				System.out.println("errore caricamento lista_file");
			}
			System.out.println("fatto!");
			
			ArrayList<Tupla_Tabella_GO> TreeXX= new ArrayList<Tupla_Tabella_GO>();
			for(FileIn f:lista_file){
				System.out.println("versione file nel sistema = "+f.versione_OBO);
				if(f.versione_OBO.compareTo(versione)==0){
					System.out.println("OBO_file "+versione+" gi presente nel sistema...");
					if(Aspect.startsWith("b")){
						ObjectInputStream ois;
						System.out.println("start load TreeBP_"+versione+"...");
						try{
							ois = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+versione+"/TreeBP"));
							TreeXX = (ArrayList<Tupla_Tabella_GO>) ois.readObject();
						}
						catch(Exception e){
							System.out.println("error during loading TreeBP_"+versione);
							e.printStackTrace();
						}
						System.out.println("done!");
					}
					if(Aspect.startsWith("c")){
						ObjectInputStream ois;
						System.out.println("start load TreeCC_"+versione+"...");
						try{
							ois = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+versione+"/TreeCC"));
							TreeXX = (ArrayList<Tupla_Tabella_GO>) ois.readObject();
						}
						catch(Exception e){
							System.out.println("error during loading TreeCC_"+versione);
							e.printStackTrace();
						}
						System.out.println("done!");
					}
					if(Aspect.startsWith("m")){
						ObjectInputStream ois;
						System.out.println("start load TreeMF_"+versione+"...");
						try{
							ois = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+versione+"/TreeMF"));
							TreeXX = (ArrayList<Tupla_Tabella_GO>) ois.readObject();
						}
						catch(Exception e){
							System.out.println("error during loading TreeMF_"+versione);
							e.printStackTrace();
						}
						System.out.println("done!");
					}
					System.out.println("dimensione TreeXX = "+TreeXX.size());
					
					
					if(termini.compareTo("NO")!=0){
						for(int tr=0;tr<terms.length;tr++){
							//System.out.println("Termine utente = "+terms[tr]);
							boolean contein = false;
					    	for(Tupla_Tabella_GO ttgo : TreeXX){
					    		//System.out.println("termine in OBO = "+ttgo.id);
					    		if(terms[tr].compareTo(ttgo.id)==0)contein=true;
					    	}
					    	if(contein)continue;
					    	else{ return "NO";}
						}
					}
					if(term.compareTo("NO")!=0){
						String[] t_a_d = term.split("-");
						t_a_d[0]=t_a_d[0].replaceAll("_", ":");
						boolean contein2 = false;
						for(Tupla_Tabella_GO tgo: TreeXX){
							if(t_a_d[0].compareTo(tgo.id)==0){
								contein2=true;
								break;
							}
						}
						if(contein2==false){ return "NO";}
					}
					return "YES";
				}
			}
			
			//parsing OBO nuova versione e creo la rispettiva cartella
			System.out.println("OBO_file "+versione+" NON presente nel sistema, creo strutture dati ad esso relative...");
			String Path_verso_OBO = Path+"sim_calc/ontologie/gene_ontology_edit.obo."+campi_versione[2]+"-"+campi_versione[1]+"-01.obo";
			ParsingOBO pa = new ParsingOBO();
			pa.storeOBO(versione, Path_verso_OBO);
			if(Aspect.startsWith("b")){
				ObjectInputStream ois;
				System.out.println("start load TreeBP_"+versione+"...");
				try{
					ois = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+versione+"/TreeBP"));
					TreeXX = (ArrayList<Tupla_Tabella_GO>) ois.readObject();
				}
				catch(Exception e){
					System.out.println("error during loading TreeBP_"+versione);
					e.printStackTrace();
				}
				System.out.println("done!");
			}
			if(Aspect.startsWith("c")){
				ObjectInputStream ois;
				System.out.println("start load TreeCC_"+versione+"...");
				try{
					ois = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+versione+"/TreeCC"));
					TreeXX = (ArrayList<Tupla_Tabella_GO>) ois.readObject();
				}
				catch(Exception e){
					System.out.println("error during loading TreeCC_"+versione);
					e.printStackTrace();
				}
				System.out.println("done!");
			}
			if(Aspect.startsWith("m")){
				ObjectInputStream ois;
				System.out.println("start load TreeMF_"+versione+"...");
				try{
					ois = new ObjectInputStream(new FileInputStream(Path+"sim_calc/"+versione+"/TreeMF"));
					TreeXX = (ArrayList<Tupla_Tabella_GO>) ois.readObject();
				}
				catch(Exception e){
					System.out.println("error during loading TreeMF_"+versione);
					e.printStackTrace();
				}
				System.out.println("done!");
			}
			System.out.println("dimensione TreeXX = "+TreeXX.size());
			
			if(termini.compareTo("NO")!=0){
				for(int tr=0;tr<terms.length;tr++){
					boolean contein = false;
					//System.out.println("Termine utente = "+terms[tr]);
			    	for(Tupla_Tabella_GO ttgo : TreeXX){
			    		//System.out.println("termine in OBO = "+ttgo.id);
			    		if(terms[tr].compareTo(ttgo.id)==0)contein=true;
			    	}
			    	if(contein)continue;
			    	else{ return "NO";}
				}
			}
			if(term.compareTo("NO")!=0){
				String[] t_a_d = term.split("-");
				t_a_d[0]=t_a_d[0].replaceAll("_", ":");
				boolean contein2 = false;
				for(Tupla_Tabella_GO tgo: TreeXX){
					if(t_a_d[0].compareTo(tgo.id)==0){
						contein2=true;
						break;
					}
				}
				if(contein2==false){ return "NO";}
			}
			return "YES";
			
	    	
	}
		public static void StoreFile(String FileName, Object structure){
			System.out.println("Storing "+FileName+"...");
			ObjectOutputStream oss;
	        try{
	            oss = new ObjectOutputStream(new FileOutputStream(FileName));
	            oss.writeObject(structure);
	            oss.close();
	        }
	        catch(Exception e1){
	                System.out.println("error during store "+FileName);
	                e1.printStackTrace();
	        }
	        System.out.println("Done!");
		}
				
}
