package sim_calc;

import java.io.*;
import java.net.*;
import java.util.*;
import java.util.zip.GZIPInputStream;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

@Path("/DownOnto")
public class DownOnto {
	
	@GET
	@Path("{mese}/{anno}")
	@Produces(MediaType.TEXT_PLAIN)
	    public String download(
	    		@PathParam("mese") String mese,
				@PathParam("anno") String anno) {
			
			String path_url = "http://www.geneontology.org/ontology-archive/gene_ontology_edit.obo.";
			String end_url = anno+"-"+mese+"-01.gz";
	        try {
	        	//System.out.println("http:\\\\localhost/tesi/workspace/sim_calc/ontologie/gene_ontology_edit.obo.");
	            URL url = new URL(path_url+end_url);
	            
	            System.out.println("Downloading ...");

	            downloadFromUrl(url, "./workspace/sim_calc/ontologie/gene_ontology_edit.obo."+end_url);

	            System.out.println("OK");
	        } catch (Exception e) {
	            System.err.println(e);
	        }
	        
	        System.out.println("decomprimo...");
	        String obo_path = "./workspace/sim_calc/ontologie/gene_ontology_edit.obo."+anno+"-"+mese+"-01.obo";
	        GZIPInputStream gzipInputStream;
			try {
				gzipInputStream = new GZIPInputStream(new FileInputStream("./workspace/sim_calc/ontologie/gene_ontology_edit.obo."+end_url));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return "NO";
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return "NO";
			}

	        OutputStream out;
			try {
				out = new FileOutputStream(obo_path);
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return "NO";
			}

	        byte[] buf = new byte[102400]; //size can be changed according to programmer's need.
	        int len;
	        try {
				while ((len = gzipInputStream.read(buf)) > 0) {
				out.write(buf, 0, len);
				}
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return "NO";
			}
	        System.out.println("fatto!");
	        return "OK";
	   }


	    public static void downloadFromUrl(URL url, String localFilename)
	    throws IOException {
	    	//System.out.println("nel metodo: "+localFilename);
	        InputStream is = null;
	        FileOutputStream fos = null;

	        try {
	            URLConnection urlConn = url.openConnection();

	            is = urlConn.getInputStream();
	            //System.out.println("prima");
	            fos = new FileOutputStream(localFilename);
	            //System.out.println("dopo");
	            byte[] buffer = new byte[4096];
	            int len;

	            while ((len = is.read(buffer)) > 0) {
	                fos.write(buffer, 0, len);
	            }
	        } finally {
	            try {
	                if (is != null) {
	                    is.close();
	                }
	            } finally {
	                if (fos != null) {
	                    fos.close();
	                }
	            }
	        }
	    }//close main
}//close class

