package sim_calc;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.ObjectInputStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Hashtable;

import org.xml.sax.HandlerBase;

public class StoreMatrix {

	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws FileNotFoundException {
		/* carico le matrici di Resnik,Lin,Jiang,RWresnik,RWlin,RWjiang.
		 * memorizzo le matrici nei file:
		 * - resnik.txt, lin.txt, jiang.txt, RWresnik.txt, RWlin.txt, RWjiang.txt.
		 * memorizzo il mapping ID-indici nelle matrici nel file:
		 * - ID_Resnik.txt
		 * memorizzo per ogni matrice: id_termine, indice, sommariga, nei file:
		 * - sommarigheresnik.txt, sommarighelin.txt, sommarighejiang.txt, sommarigheRWresnik.txt,
		 * 		sommarigheRWlin.txt, sommarigheRWjiang.txt.
		 * mentre memorizzo solo i vettori somma di ogni riga di ciascuna matrice nei file:
		 * - sommaresnik.txt, sommalin.txt, sommajiang.txt, sommaRWresnik.txt,
		 * 		sommaRWlin.txt, sommaRWjiang.txt.
		 * Queste strutture dati saranno importate in MATLAB per effettuare il confronto
		 * con le corrispondenti matrici MATLAB.
		 * 		 */
		
		//carico termini_ordinati
		ArrayList<String> termini_ordinati = new ArrayList<String>(); 
		ObjectInputStream ois0;
		System.out.println("start load termini_ordinati...");
		try{
			ois0 = new ObjectInputStream(new FileInputStream("C:/Users/jonh/workspace/sim_calc/termini_ordinati"));
			termini_ordinati = (ArrayList<String>) ois0.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading termini_ordinati");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		//carico mapping_ID_Indici
		Hashtable<String,Integer> mapping_ID_Indici = new Hashtable<String, Integer>();
		ObjectInputStream ois1;
		System.out.println("start load mapping_ID_Indici...");
		try{
			ois1 = new ObjectInputStream(new FileInputStream("C:/Users/jonh/workspace/sim_calc/mapping_ID_Indici"));
			mapping_ID_Indici = (Hashtable<String, Integer>) ois1.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading mapping_ID_Indici");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		//carico mapping_Indici_ID
		Hashtable<Integer,String> mapping_Indici_ID = new Hashtable<Integer, String>();
		ObjectInputStream ois2;
		System.out.println("start load mapping_Indici_ID...");
		try{
			ois2 = new ObjectInputStream(new FileInputStream("C:/Users/jonh/workspace/sim_calc/mapping_Indici_ID"));
			mapping_Indici_ID = (Hashtable<Integer, String>) ois2.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading mapping_Indici_ID");
			e.printStackTrace();
		}
		System.out.println("done!");
		/*
		//carico matrice di Renik
		double[][] RESNIK= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
		ObjectInputStream ois3;
		System.out.println("start load RESNIK...");
		try{
			ois3 = new ObjectInputStream(new FileInputStream("C:/Users/jonh/workspace/sim_calc/RESNIK"));
			RESNIK = (double[][]) ois3.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading RESNIK");
			e.printStackTrace();
		}
		System.out.println("done!");
		//memorizzo le info relative a resnik
		System.out.println("Memorizzo matrice RESNIK in Resnik.txt");
	    System.out.println("Memorizzo indici matrice RESNIK in ID_Resnik.txt");
	    System.out.println("Memorizzo per ogni riga di resnik:" +
	    		" nome del termine a cui siriferisce, indice, somma riga --> in sommarigheResnik.txt");
	    System.out.println("Memorizzo in sommaresnik.txt solo la somma di ogni riga di RESNIK");
	    PrintWriter out = new PrintWriter("Resnik.txt");
	    PrintWriter out2 = new PrintWriter("ID_Resnik.txt");
	    PrintWriter out3 = new PrintWriter("sommarigheResnik.txt");
	    PrintWriter out4 = new PrintWriter("sommaresnik.txt");
	    for (int i=0;i<RESNIK.length; i++) {
	    	double sommariga=0.0;
	    	for (int j=0; j<RESNIK[i].length; j++) {
	    		out.println("RESNIK["+i+"]["+j+"] = "+RESNIK[i][j] + "\n");
	    		sommariga+=RESNIK[i][j];
	    	}
	    	out.println("-----------------------------------------------");
	    	out3.println("termine: "+mapping_Indici_ID.get(i)+",  riga: "+i+" - somma = "+sommariga);
	    	out4.println(sommariga);
	    }
	    //stampo id e indici in out2
	    int dd=0;
    	int[] indici_ordinati = new int[termini_ordinati.size()];
	    for(String sre:mapping_ID_Indici.keySet()){
	    	indici_ordinati[dd]=mapping_ID_Indici.get(sre);
	    	dd++;
	    }
	    Arrays.sort(indici_ordinati);
	    for(int yi=0;yi<indici_ordinati.length;yi++){
	    	out2.println(indici_ordinati[yi]+" - "+mapping_Indici_ID.get(indici_ordinati[yi]));
	    }
	    out.close();
	    out2.close();
	    out3.close();
	    out4.close();
	    //___FINE STAMPA FILE RELATIVI A MATRICE DI RESNIK____//
	    System.out.println("fatto!");
	    */
		
		//carico matrice di Lin
		double[][] LIN= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
		ObjectInputStream ois4;
		System.out.println("start load LIN...");
		try{
			ois4 = new ObjectInputStream(new FileInputStream("C:/Users/jonh/workspace/sim_calc/LIN"));
			LIN = (double[][]) ois4.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading LIN");
			e.printStackTrace();
		}
		System.out.println("done!");
		//memorizzo info relative a lin
		System.out.println("Memorizzo matrice LIN in lin.txt");
	    System.out.println("Memorizzo per ogni riga di lin:" +
	    		" nome del termine a cui siriferisce, indice, somma riga --> in sommarighelin.txt");
	    System.out.println("Memorizzo in sommalin.txt solo la somma di ogni riga di LIN");
	    PrintWriter out5 = new PrintWriter("Lin.txt");
	    PrintWriter out6 = new PrintWriter("sommarigheLin.txt");
	    PrintWriter out7 = new PrintWriter("sommaLin.txt");
	    for (int i=0;i<LIN.length; i++) {
	    	double sommariga=0.0;
	    	for (int j=0; j<LIN[i].length; j++) {
	    		out5.println("LIN["+i+"]["+j+"] = "+LIN[i][j] + "\n");
	    		sommariga+=LIN[i][j];
	    	}
	    	out5.println("-----------------------------------------------");
	    	out6.println("termine: "+mapping_Indici_ID.get(i)+",  riga: "+i+" - somma = "+sommariga);
	    	out7.println(sommariga);
	    }
	    out5.close();
	    out6.close();
	    out7.close();
	    //___FINE STAMPA FILE RELATIVI A MATRICE DI LIN____//
	    System.out.println("fatto!");
	    
		//carico matrice di Jiang
		double[][] JIANG= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
		ObjectInputStream ois5;
		System.out.println("start load JIANG...");
		try{
			ois5 = new ObjectInputStream(new FileInputStream("C:/Users/jonh/workspace/sim_calc/JIANG"));
			JIANG = (double[][]) ois5.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading JIANG");
			e.printStackTrace();
		}
		System.out.println("done!");
		//memorizzo info relative a jiang
		System.out.println("Memorizzo matrice JINAG in Jiang.txt");
	    System.out.println("Memorizzo per ogni riga di jiang:" +
	    		" nome del termine a cui siriferisce, indice, somma riga --> in sommarigheJiang.txt");
	    System.out.println("Memorizzo in sommaJiang.txt solo la somma di ogni riga di JIANG");
	    PrintWriter out8 = new PrintWriter("Jiang.txt");
	    PrintWriter out9 = new PrintWriter("sommarigheJiang.txt");
	    PrintWriter out10 = new PrintWriter("sommaJiang.txt");
	    for (int i=0;i<JIANG.length; i++) {
	    	double sommariga=0.0;
	    	for (int j=0; j<JIANG[i].length; j++) {
	    		out8.println("JIANG["+i+"]["+j+"] = "+JIANG[i][j] + "\n");
	    		sommariga+=JIANG[i][j];
	    	}
	    	out8.println("-----------------------------------------------");
	    	out9.println("termine: "+mapping_Indici_ID.get(i)+",  riga: "+i+" - somma = "+sommariga);
	    	out10.println(sommariga);
	    }
	    out8.close();
	    out9.close();
	    out10.close();
	    //___FINE STAMPA FILE RELATIVI A MATRICE DI JIANG____//
	    System.out.println("fatto!");
		
		//carico matrice RWresnik
		double[][] RWRESNIK= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
		ObjectInputStream ois6;
		System.out.println("start load RWRESNIK...");
		try{
			ois6 = new ObjectInputStream(new FileInputStream("C:/Users/jonh/workspace/sim_calc/RWRESNIK"));
			RWRESNIK = (double[][]) ois6.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading RWRESNIK");
			e.printStackTrace();
		}
		System.out.println("done!");
		//memorizzo info relative a RWresnik
		System.out.println("Memorizzo matrice RWRESNIK in RWresnik.txt");
	    System.out.println("Memorizzo per ogni riga di RWresnik:" +
	    		" nome del termine a cui siriferisce, indice, somma riga --> in sommarigheRWresnik.txt");
	    System.out.println("Memorizzo in sommaRWresnik.txt solo la somma di ogni riga di RWresnik");
	    PrintWriter out11 = new PrintWriter("RWresnik.txt");
	    PrintWriter out12 = new PrintWriter("sommarigheRWresnik.txt");
	    PrintWriter out13 = new PrintWriter("sommaRWresnik.txt");
	    for (int i=0;i<RWRESNIK.length; i++) {
	    	double sommariga=0.0;
	    	for (int j=0; j<RWRESNIK[i].length; j++) {
	    		out11.println("RWRESNIK["+i+"]["+j+"] = "+RWRESNIK[i][j] + "\n");
	    		sommariga+=RWRESNIK[i][j];
	    	}
	    	out11.println("-----------------------------------------------");
	    	out12.println("termine: "+mapping_Indici_ID.get(i)+",  riga: "+i+" - somma = "+sommariga);
	    	out13.println(sommariga);
	    }
	    out11.close();
	    out12.close();
	    out13.close();
	    //___FINE STAMPA FILE RELATIVI A MATRICE DI RWresnik____//
	    System.out.println("fatto!");
		
		//carico matrice RWlin
		double[][] RWLIN= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
		ObjectInputStream ois7;
		System.out.println("start load RWLIN...");
		try{
			ois7 = new ObjectInputStream(new FileInputStream("C:/Users/jonh/workspace/sim_calc/RWLIN"));
			RWLIN = (double[][]) ois7.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading RWLIN");
			e.printStackTrace();
		}
		System.out.println("done!");
		//memorizzo info relative a RWlin
		System.out.println("Memorizzo matrice RWLIN in RWLin.txt");
	    System.out.println("Memorizzo per ogni riga di RWlin:" +
	    		" nome del termine a cui siriferisce, indice, somma riga --> in sommarigheRWLin.txt");
	    System.out.println("Memorizzo in sommaRWLin.txt solo la somma di ogni riga di RWLIN");
	    PrintWriter out14 = new PrintWriter("RWLin.txt");
	    PrintWriter out15 = new PrintWriter("sommarigheRWLin.txt");
	    PrintWriter out16 = new PrintWriter("sommaRWLin.txt");
	    for (int i=0;i<RWLIN.length; i++) {
	    	double sommariga=0.0;
	    	for (int j=0; j<RWLIN[i].length; j++) {
	    		out14.println("RWLIN["+i+"]["+j+"] = "+RWLIN[i][j] + "\n");
	    		sommariga+=RWLIN[i][j];
	    	}
	    	out14.println("-----------------------------------------------");
	    	out15.println("termine: "+mapping_Indici_ID.get(i)+",  riga: "+i+" - somma = "+sommariga);
	    	out16.println(sommariga);
	    }
	    out14.close();
	    out15.close();
	    out16.close();
	    //___FINE STAMPA FILE RELATIVI A MATRICE DI RWLIN____//
	    System.out.println("fatto!");
		
		//carico matrice RWjinag
		double[][] RWJIANG= new double[mapping_ID_Indici.size()][mapping_ID_Indici.size()];
		ObjectInputStream ois8;
		System.out.println("start load RWJIANG...");
		try{
			ois8 = new ObjectInputStream(new FileInputStream("C:/Users/jonh/workspace/sim_calc/RWJIANG"));
			RWJIANG = (double[][]) ois8.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading RWJIANG");
			e.printStackTrace();
		}
		System.out.println("done!");
		//memorizzo info relative a RWJIANG
		System.out.println("Memorizzo matrice RWJIANG in RWJiang.txt");
	    System.out.println("Memorizzo per ogni riga di RWjiang:" +
	    		" nome del termine a cui siriferisce, indice, somma riga --> in sommarigheRWJiang.txt");
	    System.out.println("Memorizzo in sommaRWJiang.txt solo la somma di ogni riga di RWJIANG");
	    PrintWriter out17 = new PrintWriter("RWJiang.txt");
	    PrintWriter out18 = new PrintWriter("sommarigheRWJiang.txt");
	    PrintWriter out19 = new PrintWriter("sommaRWJiang.txt");
	    for (int i=0;i<RWJIANG.length; i++) {
	    	double sommariga=0.0;
	    	for (int j=0; j<RWJIANG[i].length; j++) {
	    		out17.println("RWJIANG["+i+"]["+j+"] = "+RWJIANG[i][j] + "\n");
	    		sommariga+=RWJIANG[i][j];
	    	}
	    	out17.println("-----------------------------------------------");
	    	out18.println("termine: "+mapping_Indici_ID.get(i)+",  riga: "+i+" - somma = "+sommariga);
	    	out19.println(sommariga);
	    }
	    out17.close();
	    out18.close();
	    out19.close();
	    //___FINE STAMPA FILE RELATIVI A MATRICE DI RWJIANG____//
	    System.out.println("fatto!");
		

	}

}
