package sim_calc;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.Hashtable;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import annotation.Annotation_parser_reduced;
import annotation.ParsingAnnotatioFile;

import obo.BinarioDecimale;
import obo.Get_JIANG;
import obo.Get_LIN;
import obo.Get_RESNIK;
import obo.Get_RandomWalk;
import obo.Get_TREE_LCA;
import obo.Get_TREE_P;
import obo.Misura;
import obo.OBOReader;
import obo.ParsingOBO;
import obo.TermInfo;
import obo.ThreadCalcola;
import obo.ThreadCalcolaGene;
import obo.Tupla_Tabella_GO;

/* Questa classe realizza il binding con l'interfaccia utente.
 * Preleva i dati forniti dall'utente che sono incapsulati nell'URL che contiene la richiesta HTTP,
 * carica le strutture dati presenti in memoria per calcolare le misure di similarit richieste per i termini
 * forniti dall'utente. In memoria sono memorizzate (per ora) solo le strutture dati ottenute selezionando
 * come evidence code da ignorare quelle di default e come termini solo quelli apparteneti al dominio CC.
 * Nell'estensione completa, verr fatto un controllo sugli evidence_code forniti dall'utente e sul dominio
 * scelto, quindi, se si possiedono gi in memoria le strutture dati necessarie, queste verranno caricate,
 *  altrimenti dovranno essere generate (operazione che richiede alcuni minuti). */
@Path("/Gene")
public class Gene {
	public Misura mi;
	public static String Risultati;
	
	@GET
	@Path("{version}/{branch}/{genes}/{organism}/{evidence}/{measures}")
	@Produces(MediaType.TEXT_PLAIN)
	public String post(
			@PathParam("version") String versione,
			@PathParam("branch") String Aspect,
			@PathParam("genes") String termini,
			@PathParam("organism") String organism,
			@PathParam("evidence") String evidence,
			@PathParam("measures") String misure) {
		
			String Path = "./workspace/";
			Risultati = "NO";
			mi = new Misura();
		
			String[] campi_versione = versione.split("-");
			if(campi_versione[1].length()==1){
				campi_versione[1]="0"+campi_versione[1];
				versione = campi_versione[0]+"-"+campi_versione[1]+"-"+campi_versione[2];
			}
			mi.finish=false;
			
			System.out.println("FINISH = "+mi.getfinish());
			mi.versione = versione;
			mi.termini=termini;
			System.out.println("versione = "+versione);
			System.out.println("branch = "+Aspect);
			mi.Aspect=Aspect;
			System.out.println("termini1 = "+termini);
			String[] terms = termini.split("&");
			System.out.println("termini:");
			for(int ca=0;ca<terms.length;ca++){
				System.out.println(terms[ca]);
			}
			mi.terms=terms;
			
			System.out.println("organismo = "+organism);
			mi.organism=organism;
			System.out.println("evidence code da ignorare:/n ");
			String[] evi=evidence.split("-");
			ArrayList<String> ev_def = new ArrayList<String>();
			for(int ww=0;ww<evi.length;ww++){
				System.out.println(evi[ww]);
				ev_def.add(evi[ww]);
			}
			mi.ev_def=ev_def;
			System.out.println("misure:/n");
			String[] measur = misure.split("-");
			for(int hh=0;hh<measur.length;hh++){
				System.out.println(measur[hh]);
			}
			mi.measur=measur;
			System.out.println("determino codice evidence...");
			String codice1;
			String codice2;
			if(ev_def.contains("IEA"))codice1="1";else codice1="0";
			if(ev_def.contains("NR"))codice1=codice1+"1";else codice1=codice1+"0";
			if(ev_def.contains("ND"))codice1=codice1+"1";else codice1=codice1+"0";
			if(ev_def.contains("IC"))codice1=codice1+"1";else codice1=codice1+"0";
			if(ev_def.contains("IMP"))codice1=codice1+"1";else codice1=codice1+"0";
			if(ev_def.contains("IPI"))codice1=codice1+"1";else codice1=codice1+"0";
			if(ev_def.contains("ISS"))codice1=codice1+"1";else codice1=codice1+"0";
			if(ev_def.contains("EXP"))codice1=codice1+"1";else codice1=codice1+"0";
			if(ev_def.contains("IDA"))codice1=codice1+"1";else codice1=codice1+"0";
			if(ev_def.contains("IGI"))codice1=codice1+"1";else codice1=codice1+"0";
			if(ev_def.contains("IEP"))codice1=codice1+"1";else codice1=codice1+"0";
			
			if(ev_def.contains("ISO"))codice2="1";else codice2="0";
			if(ev_def.contains("ISA"))codice2=codice2+"1";else codice2=codice2+"0";
			if(ev_def.contains("ISM"))codice2=codice2+"1";else codice2=codice2+"0";
			if(ev_def.contains("IGC"))codice2=codice2+"1";else codice2=codice2+"0";
			if(ev_def.contains("IBA"))codice2=codice2+"1";else codice2=codice2+"0";
			if(ev_def.contains("IBD"))codice2=codice2+"1";else codice2=codice2+"0";
			if(ev_def.contains("IKR"))codice2=codice2+"1";else codice2=codice2+"0";
			if(ev_def.contains("IRD"))codice2=codice2+"1";else codice2=codice2+"0";
			if(ev_def.contains("RCA"))codice2=codice2+"1";else codice2=codice2+"0";
			if(ev_def.contains("TAS"))codice2=codice2+"1";else codice2=codice2+"0";
			if(ev_def.contains("NAS"))codice2=codice2+"1";else codice2=codice2+"0";
			
			System.out.println("codici evidence = "+codice1+"-"+codice2);
			BinarioDecimale bd = new BinarioDecimale();
			int cod1_dec = (int)bd.convertitore(codice1, 11);
			int cod2_dec = (int)bd.convertitore(codice2, 11);
			System.out.println("codice decimale evidence = "+cod1_dec+"-"+cod2_dec);
			String cod_dec_ev = cod1_dec+"-"+cod2_dec;
			mi.cod_dec_ev=cod_dec_ev;
			
			/* determino la lista dei geni inseriti dall'utente */
			ArrayList<String> lista_geni = new ArrayList<String>();
			if(mi.termini.compareTo("NO")!=0){//se ci sono termini da LISTA
			    System.out.println("entro LISTA");
			    for(int d=0;d<mi.terms.length;d++){
			    	lista_geni.add(mi.terms[d]);
			    }
			}
			//------------------------------//
			
			/* questo thread determina la lista dei termini annotati con ciascun gene
			 * e calcola la similarit tra ogni coppia di geni inseriti dall'utente */
			System.out.println("creo Thrad");
			ThreadCalcolaGene tc = new ThreadCalcolaGene(mi, Path,ev_def,lista_geni);
			System.out.println("avvio Thrad");
			tc.start();
			return "token";
	
	}//chiude metodo principale
	
	@GET
	@Path("{token}")
	@Produces(MediaType.TEXT_PLAIN)
	public String get_token(
			@PathParam("token") String token){
		if(get_Risultati().compareTo("NO")!=0){
			
			return get_Risultati();
		}
		else return "wait";
		
	}
	
	public static synchronized String get_Risultati(){
		return Risultati;
	}
	
	public static synchronized void set_Risultati(String res){
		Risultati = res;
	}
	
	public static double arrotondaPerEccesso(double valore, int cifreDecimali) {
	    double fattore = Math.pow(10, cifreDecimali);
	    return Math.ceil(valore * fattore) / fattore;
	}
	
	
}
